/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         yangparse
#define yylex           yanglex
#define yyerror         yangerror
#define yydebug         yangdebug
#define yynerrs         yangnerrs

/* First part of user prologue.  */
#line 17 "parser-yang.y"


#include <config.h>
    
#ifdef BACKEND_YANG

#define _ISOC99_SOURCE
#define _DEFAULT_SOURCE
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <limits.h>
#include <float.h>

#if defined(_MSC_VER)
#include <malloc.h>
#endif

#include "yang.h"
#include "yang-data.h"
#include "parser-yang.h"
#include "scanner-yang.h"
#include "yang-complex-types.h"
#include "util.h"
#include "error.h"
#include "yang-check.h"

#ifdef HAVE_DMALLOC_H
#include <dmalloc.h>
#endif


#define thisParserPtr      ((Parser *)parserPtr)
#define thisModulePtr      (((Parser *)parserPtr)->yangModulePtr)
#define thisModuleInfoPtr  ((_YangModuleInfo*)((Parser *)parserPtr)->yangModulePtr->info)

#define SMI_EPOCH	631152000	/* 01 Jan 1990 00:00:00 */ 

#define DEBUG

#ifdef DEBUG 
#define debug(args...) fprintf (stderr, args);
#else
#define debug
#endif

extern void createIdentifierRef(struct _YangNode *node, char* prefix, char* ident);
extern void smiyyerror(char *msg, Parser *parserPtr);
/*
 * NOTE: The argument lvalp ist not really a void pointer. Unfortunately,
 * we don't know it better at this point. bison generated C code declares
 * YYSTYPE just a few lines below based on the `%union' declaration.
 */
extern int yylex(void *lvalp, Parser *parserPtr);

/* The declaration stack is used to determine what is the parrent
 * statement of the current one. It helps to write generic
 * substatements like the description statement which calls the
 * function setDescription, which in turn checks the current
 * statement type(decl) and uses the a global pointer to the 
 * current parent statement to set the description. 
 */
typedef struct declStack {
    YangDecl decl;
    _YangNode* node;
    struct declStack *down;
} declStack;

static declStack *dStack = NULL;

static void pushDecl(YangDecl decl)
{
    declStack *top = (declStack*)smiMalloc(sizeof(declStack));
    top->down = NULL;
    top->decl = decl;
	
    if(dStack == NULL) {
        dStack = top;
    } else {
        top->down = dStack;
        dStack = top;
    }
}

static void pushNode(_YangNode* node)
{
    declStack *top = (declStack*)smiMalloc(sizeof(declStack));
    top->down = NULL;
    top->node = node;
    if (node) {
        top->decl = node->export.nodeKind;
    }
	
    if(dStack == NULL) {
        dStack = top;
    } else {
        top->down = dStack;
        dStack = top;
    }
}

static void pop()
{
    declStack *top;
    if(dStack != NULL)
    {
        top = dStack;
        dStack = dStack->down;
        free(top);
    }
}

static YangDecl topDecl()
{
    if (dStack == NULL)
    {
        return YANG_DECL_UNKNOWN;
    }
    else
    {
        return dStack->decl;
    }
}

static _YangNode* topNode()
{
    if (dStack == NULL)
    {
        return NULL;
    }
    else
    {
        return dStack->node;
    }
}

Parser *currentParser = NULL;

static _YangNode *node = NULL;

char* getPrefix(char* identifierRef) {
    char* colonIndex = strchr(identifierRef, ':');
    if (!colonIndex) return NULL;
    return smiStrndup(identifierRef, colonIndex - identifierRef);
}

char* getIdentifier(char* identifierRef) {
    char* colonIndex = strchr(identifierRef, ':');
    if (!colonIndex) return smiStrdup(identifierRef);
    return smiStrdup(colonIndex + 1);
}

void checkUnknownStatement() {
    if (topNode()->export.nodeKind == YANG_DECL_UNKNOWN_STATEMENT) {
        _YangNode *childPtr = NULL;
        for (childPtr = topNode()->firstChildPtr; childPtr; childPtr = childPtr->nextSiblingPtr) {
            if (childPtr->export.nodeKind != YANG_DECL_UNKNOWN_STATEMENT) {
                smiPrintErrorAtLine(currentParser, ERR_UNEXPECTED_KEYWORD, childPtr->line, yangDeclAsString(childPtr->export.nodeKind));
            }
        }
    }
}


static time_t
checkDate(Parser *parserPtr, char *date)
{
    struct tm	tm;
    time_t	anytime;
    int		i, len;
    char	*p;

    memset(&tm, 0, sizeof(tm));
    anytime = 0;

    len = strlen(date);
    if (len == 10 || len == 16) {
        for (i = 0; i < len; i++) {
            if (((i < 4 || i == 5 || i == 6 || i == 8 || i == 9 || i == 11
              || i == 12 || i == 14 || i == 15) && ! isdigit((int)date[i]))
            || ((i == 4 || i == 7) && date[i] != '-')
            || (i == 10 && date[i] != ' ')
            || (i == 13 && date[i] != ':')) {
            smiPrintError(parserPtr, ERR_DATE_CHARACTER, date);
            anytime = (time_t) -1;
            break;
            }
        }
    } else {
        smiPrintError(parserPtr, ERR_DATE_LENGTH, date);
        anytime = (time_t) -1;
    }
    
    if (anytime == 0) {
	for (i = 0, p = date, tm.tm_year = 0; i < 4; i++, p++) {
	    tm.tm_year = tm.tm_year * 10 + (*p - '0');
	}
	p++;
	tm.tm_mon = (p[0]-'0') * 10 + (p[1]-'0');
	p += 3;
	tm.tm_mday = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	if (len == 16) {
	    p++;
	    tm.tm_hour = (p[0]-'0') * 10 + (p[1]-'0');
	    p += 3;
	    tm.tm_min = (p[0]-'0') * 10 + (p[1]-'0');
	}
	
	if (tm.tm_mon < 1 || tm.tm_mon > 12) {
	    smiPrintError(parserPtr, ERR_DATE_MONTH, date);
	}
	if (tm.tm_mday < 1 || tm.tm_mday > 31) {
	    smiPrintError(parserPtr, ERR_DATE_DAY, date);
	}
	if (tm.tm_hour < 0 || tm.tm_hour > 23) {
	    smiPrintError(parserPtr, ERR_DATE_HOUR, date);
	}
	if (tm.tm_min < 0 || tm.tm_min > 59) {
	    smiPrintError(parserPtr, ERR_DATE_MINUTES, date);
	}
	
	tm.tm_year -= 1900;
	tm.tm_mon -= 1;
	tm.tm_isdst = 0;

	anytime = timegm(&tm);

	if (anytime == (time_t) -1) {
	    smiPrintError(parserPtr, ERR_DATE_VALUE, date);
	} else {
	    if (anytime < SMI_EPOCH) {
            smiPrintError(parserPtr, ERR_DATE_IN_PAST, date);
	    }
	    if (anytime > time(NULL)) {
            smiPrintError(parserPtr, ERR_DATE_IN_FUTURE, date);
	    }
	}
    }
    
    return (anytime == (time_t) -1) ? 0 : anytime;
}


#line 324 "parser-yang.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser-yang.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_augmentKeyword = 3,             /* augmentKeyword  */
  YYSYMBOL_belongs_toKeyword = 4,          /* belongs_toKeyword  */
  YYSYMBOL_choiceKeyword = 5,              /* choiceKeyword  */
  YYSYMBOL_configKeyword = 6,              /* configKeyword  */
  YYSYMBOL_contactKeyword = 7,             /* contactKeyword  */
  YYSYMBOL_containerKeyword = 8,           /* containerKeyword  */
  YYSYMBOL_defaultKeyword = 9,             /* defaultKeyword  */
  YYSYMBOL_descriptionKeyword = 10,        /* descriptionKeyword  */
  YYSYMBOL_fractionDigitsKeyword = 11,     /* fractionDigitsKeyword  */
  YYSYMBOL_enumKeyword = 12,               /* enumKeyword  */
  YYSYMBOL_error_app_tagKeyword = 13,      /* error_app_tagKeyword  */
  YYSYMBOL_error_messageKeyword = 14,      /* error_messageKeyword  */
  YYSYMBOL_extensionKeyword = 15,          /* extensionKeyword  */
  YYSYMBOL_groupingKeyword = 16,           /* groupingKeyword  */
  YYSYMBOL_importKeyword = 17,             /* importKeyword  */
  YYSYMBOL_includeKeyword = 18,            /* includeKeyword  */
  YYSYMBOL_keyKeyword = 19,                /* keyKeyword  */
  YYSYMBOL_leafKeyword = 20,               /* leafKeyword  */
  YYSYMBOL_leaf_listKeyword = 21,          /* leaf_listKeyword  */
  YYSYMBOL_lengthKeyword = 22,             /* lengthKeyword  */
  YYSYMBOL_listKeyword = 23,               /* listKeyword  */
  YYSYMBOL_mandatoryKeyword = 24,          /* mandatoryKeyword  */
  YYSYMBOL_max_elementsKeyword = 25,       /* max_elementsKeyword  */
  YYSYMBOL_min_elementsKeyword = 26,       /* min_elementsKeyword  */
  YYSYMBOL_moduleKeyword = 27,             /* moduleKeyword  */
  YYSYMBOL_submoduleKeyword = 28,          /* submoduleKeyword  */
  YYSYMBOL_mustKeyword = 29,               /* mustKeyword  */
  YYSYMBOL_namespaceKeyword = 30,          /* namespaceKeyword  */
  YYSYMBOL_ordered_byKeyword = 31,         /* ordered_byKeyword  */
  YYSYMBOL_organizationKeyword = 32,       /* organizationKeyword  */
  YYSYMBOL_prefixKeyword = 33,             /* prefixKeyword  */
  YYSYMBOL_rangeKeyword = 34,              /* rangeKeyword  */
  YYSYMBOL_referenceKeyword = 35,          /* referenceKeyword  */
  YYSYMBOL_patternKeyword = 36,            /* patternKeyword  */
  YYSYMBOL_revisionKeyword = 37,           /* revisionKeyword  */
  YYSYMBOL_statusKeyword = 38,             /* statusKeyword  */
  YYSYMBOL_typeKeyword = 39,               /* typeKeyword  */
  YYSYMBOL_typedefKeyword = 40,            /* typedefKeyword  */
  YYSYMBOL_uniqueKeyword = 41,             /* uniqueKeyword  */
  YYSYMBOL_unitsKeyword = 42,              /* unitsKeyword  */
  YYSYMBOL_usesKeyword = 43,               /* usesKeyword  */
  YYSYMBOL_valueKeyword = 44,              /* valueKeyword  */
  YYSYMBOL_whenKeyword = 45,               /* whenKeyword  */
  YYSYMBOL_bitKeyword = 46,                /* bitKeyword  */
  YYSYMBOL_pathKeyword = 47,               /* pathKeyword  */
  YYSYMBOL_anyXMLKeyword = 48,             /* anyXMLKeyword  */
  YYSYMBOL_deprecatedKeyword = 49,         /* deprecatedKeyword  */
  YYSYMBOL_currentKeyword = 50,            /* currentKeyword  */
  YYSYMBOL_obsoleteKeyword = 51,           /* obsoleteKeyword  */
  YYSYMBOL_trueKeyword = 52,               /* trueKeyword  */
  YYSYMBOL_falseKeyword = 53,              /* falseKeyword  */
  YYSYMBOL_caseKeyword = 54,               /* caseKeyword  */
  YYSYMBOL_inputKeyword = 55,              /* inputKeyword  */
  YYSYMBOL_outputKeyword = 56,             /* outputKeyword  */
  YYSYMBOL_rpcKeyword = 57,                /* rpcKeyword  */
  YYSYMBOL_notificationKeyword = 58,       /* notificationKeyword  */
  YYSYMBOL_argumentKeyword = 59,           /* argumentKeyword  */
  YYSYMBOL_yangversionKeyword = 60,        /* yangversionKeyword  */
  YYSYMBOL_baseKeyword = 61,               /* baseKeyword  */
  YYSYMBOL_deviationKeyword = 62,          /* deviationKeyword  */
  YYSYMBOL_deviateKeyword = 63,            /* deviateKeyword  */
  YYSYMBOL_featureKeyword = 64,            /* featureKeyword  */
  YYSYMBOL_identityKeyword = 65,           /* identityKeyword  */
  YYSYMBOL_ifFeatureKeyword = 66,          /* ifFeatureKeyword  */
  YYSYMBOL_positionKeyword = 67,           /* positionKeyword  */
  YYSYMBOL_presenceKeyword = 68,           /* presenceKeyword  */
  YYSYMBOL_refineKeyword = 69,             /* refineKeyword  */
  YYSYMBOL_requireInstanceKeyword = 70,    /* requireInstanceKeyword  */
  YYSYMBOL_yinElementKeyword = 71,         /* yinElementKeyword  */
  YYSYMBOL_notSupportedKeyword = 72,       /* notSupportedKeyword  */
  YYSYMBOL_addKeyword = 73,                /* addKeyword  */
  YYSYMBOL_deleteKeyword = 74,             /* deleteKeyword  */
  YYSYMBOL_replaceKeyword = 75,            /* replaceKeyword  */
  YYSYMBOL_complexTypeKeyword = 76,        /* complexTypeKeyword  */
  YYSYMBOL_extendsKeyword = 77,            /* extendsKeyword  */
  YYSYMBOL_abstractKeyword = 78,           /* abstractKeyword  */
  YYSYMBOL_instanceKeyword = 79,           /* instanceKeyword  */
  YYSYMBOL_instanceListKeyword = 80,       /* instanceListKeyword  */
  YYSYMBOL_instanceTypeKeyword = 81,       /* instanceTypeKeyword  */
  YYSYMBOL_identifier = 82,                /* identifier  */
  YYSYMBOL_identifierRefArg = 83,          /* identifierRefArg  */
  YYSYMBOL_identifierRefArgStr = 84,       /* identifierRefArgStr  */
  YYSYMBOL_dateString = 85,                /* dateString  */
  YYSYMBOL_yangVersion = 86,               /* yangVersion  */
  YYSYMBOL_qString = 87,                   /* qString  */
  YYSYMBOL_uqString = 88,                  /* uqString  */
  YYSYMBOL_decimalNumber = 89,             /* decimalNumber  */
  YYSYMBOL_floatNumber = 90,               /* floatNumber  */
  YYSYMBOL_hexNumber = 91,                 /* hexNumber  */
  YYSYMBOL_92_ = 92,                       /* '{'  */
  YYSYMBOL_93_ = 93,                       /* '}'  */
  YYSYMBOL_94_ = 94,                       /* ';'  */
  YYSYMBOL_YYACCEPT = 95,                  /* $accept  */
  YYSYMBOL_yangFile = 96,                  /* yangFile  */
  YYSYMBOL_moduleStatement = 97,           /* moduleStatement  */
  YYSYMBOL_98_1 = 98,                      /* $@1  */
  YYSYMBOL_submoduleStatement = 99,        /* submoduleStatement  */
  YYSYMBOL_100_2 = 100,                    /* $@2  */
  YYSYMBOL_moduleHeaderStatement_0n = 101, /* moduleHeaderStatement_0n  */
  YYSYMBOL_moduleHeaderStatement0_n = 102, /* moduleHeaderStatement0_n  */
  YYSYMBOL_moduleHeaderStatement = 103,    /* moduleHeaderStatement  */
  YYSYMBOL_moduleMetaStatement_0n = 104,   /* moduleMetaStatement_0n  */
  YYSYMBOL_moduleMetaStatement = 105,      /* moduleMetaStatement  */
  YYSYMBOL_submoduleHeaderStatement = 106, /* submoduleHeaderStatement  */
  YYSYMBOL_belongsToStatement = 107,       /* belongsToStatement  */
  YYSYMBOL_108_3 = 108,                    /* $@3  */
  YYSYMBOL_linkageStatement_0n = 109,      /* linkageStatement_0n  */
  YYSYMBOL_linkageStatement = 110,         /* linkageStatement  */
  YYSYMBOL_revisionStatement_0n = 111,     /* revisionStatement_0n  */
  YYSYMBOL_bodyStatement_0n = 112,         /* bodyStatement_0n  */
  YYSYMBOL_bodyStatement = 113,            /* bodyStatement  */
  YYSYMBOL_dataDefStatement = 114,         /* dataDefStatement  */
  YYSYMBOL_commonStatement = 115,          /* commonStatement  */
  YYSYMBOL_organizationStatement = 116,    /* organizationStatement  */
  YYSYMBOL_contactStatement = 117,         /* contactStatement  */
  YYSYMBOL_descriptionStatement = 118,     /* descriptionStatement  */
  YYSYMBOL_referenceStatement = 119,       /* referenceStatement  */
  YYSYMBOL_statusStatement = 120,          /* statusStatement  */
  YYSYMBOL_namespaceStatement = 121,       /* namespaceStatement  */
  YYSYMBOL_yangVersionStatement = 122,     /* yangVersionStatement  */
  YYSYMBOL_status = 123,                   /* status  */
  YYSYMBOL_prefixStatement = 124,          /* prefixStatement  */
  YYSYMBOL_revisionStatement = 125,        /* revisionStatement  */
  YYSYMBOL_126_4 = 126,                    /* $@4  */
  YYSYMBOL_revisionSubstatement_On = 127,  /* revisionSubstatement_On  */
  YYSYMBOL_revisionSubstatement = 128,     /* revisionSubstatement  */
  YYSYMBOL_date = 129,                     /* date  */
  YYSYMBOL_importStatement = 130,          /* importStatement  */
  YYSYMBOL_131_5 = 131,                    /* $@5  */
  YYSYMBOL_optionalRevision = 132,         /* optionalRevision  */
  YYSYMBOL_includeStatement = 133,         /* includeStatement  */
  YYSYMBOL_134_6 = 134,                    /* $@6  */
  YYSYMBOL_includeStatementBody = 135,     /* includeStatementBody  */
  YYSYMBOL_featureStatement = 136,         /* featureStatement  */
  YYSYMBOL_137_7 = 137,                    /* $@7  */
  YYSYMBOL_featureSpec = 138,              /* featureSpec  */
  YYSYMBOL_featureSubstatement_0n = 139,   /* featureSubstatement_0n  */
  YYSYMBOL_featureSubstatement = 140,      /* featureSubstatement  */
  YYSYMBOL_ifFeatureStatement = 141,       /* ifFeatureStatement  */
  YYSYMBOL_identityStatement = 142,        /* identityStatement  */
  YYSYMBOL_143_8 = 143,                    /* $@8  */
  YYSYMBOL_identitySpec = 144,             /* identitySpec  */
  YYSYMBOL_identitySubstatement_0n = 145,  /* identitySubstatement_0n  */
  YYSYMBOL_identitySubstatement = 146,     /* identitySubstatement  */
  YYSYMBOL_typedefStatement = 147,         /* typedefStatement  */
  YYSYMBOL_148_9 = 148,                    /* $@9  */
  YYSYMBOL_typedefSubstatement_0n = 149,   /* typedefSubstatement_0n  */
  YYSYMBOL_typedefSubstatement = 150,      /* typedefSubstatement  */
  YYSYMBOL_typeStatement = 151,            /* typeStatement  */
  YYSYMBOL_152_10 = 152,                   /* $@10  */
  YYSYMBOL_optionalTypeBodyStatements = 153, /* optionalTypeBodyStatements  */
  YYSYMBOL_typeBodyStmts = 154,            /* typeBodyStmts  */
  YYSYMBOL_numRestriction = 155,           /* numRestriction  */
  YYSYMBOL_range = 156,                    /* range  */
  YYSYMBOL_157_11 = 157,                   /* $@11  */
  YYSYMBOL_fractionDigitsStatement = 158,  /* fractionDigitsStatement  */
  YYSYMBOL_stringRestriction_0n = 159,     /* stringRestriction_0n  */
  YYSYMBOL_stringRestriction = 160,        /* stringRestriction  */
  YYSYMBOL_length = 161,                   /* length  */
  YYSYMBOL_162_12 = 162,                   /* $@12  */
  YYSYMBOL_pattern = 163,                  /* pattern  */
  YYSYMBOL_164_13 = 164,                   /* $@13  */
  YYSYMBOL_enumSpec = 165,                 /* enumSpec  */
  YYSYMBOL_enum = 166,                     /* enum  */
  YYSYMBOL_167_14 = 167,                   /* $@14  */
  YYSYMBOL_enumSubstatementSpec = 168,     /* enumSubstatementSpec  */
  YYSYMBOL_enumSubstatement_0n = 169,      /* enumSubstatement_0n  */
  YYSYMBOL_enumSubstatement = 170,         /* enumSubstatement  */
  YYSYMBOL_valueStatement = 171,           /* valueStatement  */
  YYSYMBOL_optionalRestrictionSpec = 172,  /* optionalRestrictionSpec  */
  YYSYMBOL_restrictionSpec_0n = 173,       /* restrictionSpec_0n  */
  YYSYMBOL_restrictionSpec = 174,          /* restrictionSpec  */
  YYSYMBOL_errorMessageStatement = 175,    /* errorMessageStatement  */
  YYSYMBOL_errorAppTagStatement = 176,     /* errorAppTagStatement  */
  YYSYMBOL_leafrefSpec = 177,              /* leafrefSpec  */
  YYSYMBOL_path = 178,                     /* path  */
  YYSYMBOL_requireInstanceStatement = 179, /* requireInstanceStatement  */
  YYSYMBOL_identityrefSpec = 180,          /* identityrefSpec  */
  YYSYMBOL_baseStatement = 181,            /* baseStatement  */
  YYSYMBOL_bitsSpec = 182,                 /* bitsSpec  */
  YYSYMBOL_bitsStatement = 183,            /* bitsStatement  */
  YYSYMBOL_184_15 = 184,                   /* $@15  */
  YYSYMBOL_bitsSubstatementSpec = 185,     /* bitsSubstatementSpec  */
  YYSYMBOL_bitsSubstatement_0n = 186,      /* bitsSubstatement_0n  */
  YYSYMBOL_bitsSubstatement = 187,         /* bitsSubstatement  */
  YYSYMBOL_positionStatement = 188,        /* positionStatement  */
  YYSYMBOL_unionSpec = 189,                /* unionSpec  */
  YYSYMBOL_stmtEnd = 190,                  /* stmtEnd  */
  YYSYMBOL_stmtSep = 191,                  /* stmtSep  */
  YYSYMBOL_unknownStatement0_n = 192,      /* unknownStatement0_n  */
  YYSYMBOL_complexTypeStatement = 193,     /* complexTypeStatement  */
  YYSYMBOL_194_16 = 194,                   /* $@16  */
  YYSYMBOL_complexTypeSpec = 195,          /* complexTypeSpec  */
  YYSYMBOL_complexTypeSubstatement_0n = 196, /* complexTypeSubstatement_0n  */
  YYSYMBOL_complexTypeSubstatement = 197,  /* complexTypeSubstatement  */
  YYSYMBOL_abstractStatement = 198,        /* abstractStatement  */
  YYSYMBOL_extendsStatement = 199,         /* extendsStatement  */
  YYSYMBOL_200_17 = 200,                   /* $@17  */
  YYSYMBOL_extendsStatementSpec = 201,     /* extendsStatementSpec  */
  YYSYMBOL_extendsSubstatement_0n = 202,   /* extendsSubstatement_0n  */
  YYSYMBOL_extendsSubstatement = 203,      /* extendsSubstatement  */
  YYSYMBOL_instanceStatement = 204,        /* instanceStatement  */
  YYSYMBOL_205_18 = 205,                   /* $@18  */
  YYSYMBOL_instanceSubstatement_0n = 206,  /* instanceSubstatement_0n  */
  YYSYMBOL_instanceSubstatement = 207,     /* instanceSubstatement  */
  YYSYMBOL_instanceListStatement = 208,    /* instanceListStatement  */
  YYSYMBOL_209_19 = 209,                   /* $@19  */
  YYSYMBOL_instanceListSubstatement_0n = 210, /* instanceListSubstatement_0n  */
  YYSYMBOL_instanceListSubstatement = 211, /* instanceListSubstatement  */
  YYSYMBOL_instanceTypeStatement = 212,    /* instanceTypeStatement  */
  YYSYMBOL_unknownStatement = 213,         /* unknownStatement  */
  YYSYMBOL_214_20 = 214,                   /* $@20  */
  YYSYMBOL_215_21 = 215,                   /* $@21  */
  YYSYMBOL_containerStatement = 216,       /* containerStatement  */
  YYSYMBOL_217_22 = 217,                   /* $@22  */
  YYSYMBOL_containerSpec = 218,            /* containerSpec  */
  YYSYMBOL_containerSubstatement_0n = 219, /* containerSubstatement_0n  */
  YYSYMBOL_containerSubstatement = 220,    /* containerSubstatement  */
  YYSYMBOL_mustStatement = 221,            /* mustStatement  */
  YYSYMBOL_222_23 = 222,                   /* $@23  */
  YYSYMBOL_mustSubstatement_0n = 223,      /* mustSubstatement_0n  */
  YYSYMBOL_mustSubstatement = 224,         /* mustSubstatement  */
  YYSYMBOL_presenceStatement = 225,        /* presenceStatement  */
  YYSYMBOL_configStatement = 226,          /* configStatement  */
  YYSYMBOL_mandatoryStatement = 227,       /* mandatoryStatement  */
  YYSYMBOL_leafStatement = 228,            /* leafStatement  */
  YYSYMBOL_229_24 = 229,                   /* $@24  */
  YYSYMBOL_leafSubstatement_0n = 230,      /* leafSubstatement_0n  */
  YYSYMBOL_leafSubstatement = 231,         /* leafSubstatement  */
  YYSYMBOL_leaf_listStatement = 232,       /* leaf_listStatement  */
  YYSYMBOL_233_25 = 233,                   /* $@25  */
  YYSYMBOL_leaf_listSubstatement_0n = 234, /* leaf_listSubstatement_0n  */
  YYSYMBOL_leaf_listSubstatement = 235,    /* leaf_listSubstatement  */
  YYSYMBOL_listStatement = 236,            /* listStatement  */
  YYSYMBOL_237_26 = 237,                   /* $@26  */
  YYSYMBOL_listSubstatement_0n = 238,      /* listSubstatement_0n  */
  YYSYMBOL_listSubstatement = 239,         /* listSubstatement  */
  YYSYMBOL_max_elementsStatement = 240,    /* max_elementsStatement  */
  YYSYMBOL_min_elementsStatement = 241,    /* min_elementsStatement  */
  YYSYMBOL_ordered_byStatement = 242,      /* ordered_byStatement  */
  YYSYMBOL_keyStatement = 243,             /* keyStatement  */
  YYSYMBOL_uniqueStatement = 244,          /* uniqueStatement  */
  YYSYMBOL_choiceStatement = 245,          /* choiceStatement  */
  YYSYMBOL_246_27 = 246,                   /* $@27  */
  YYSYMBOL_choiceSpec = 247,               /* choiceSpec  */
  YYSYMBOL_choiceSubstatement_0n = 248,    /* choiceSubstatement_0n  */
  YYSYMBOL_choiceSubstatement = 249,       /* choiceSubstatement  */
  YYSYMBOL_caseStatement = 250,            /* caseStatement  */
  YYSYMBOL_251_28 = 251,                   /* $@28  */
  YYSYMBOL_caseSpec = 252,                 /* caseSpec  */
  YYSYMBOL_caseSubstatement_0n = 253,      /* caseSubstatement_0n  */
  YYSYMBOL_caseSubstatement = 254,         /* caseSubstatement  */
  YYSYMBOL_caseDataDef = 255,              /* caseDataDef  */
  YYSYMBOL_groupingStatement = 256,        /* groupingStatement  */
  YYSYMBOL_257_29 = 257,                   /* $@29  */
  YYSYMBOL_groupingSubstatement_0n = 258,  /* groupingSubstatement_0n  */
  YYSYMBOL_groupingSubstatement = 259,     /* groupingSubstatement  */
  YYSYMBOL_usesStatement = 260,            /* usesStatement  */
  YYSYMBOL_261_30 = 261,                   /* $@30  */
  YYSYMBOL_usesSubstatement_0n = 262,      /* usesSubstatement_0n  */
  YYSYMBOL_usesSubstatement = 263,         /* usesSubstatement  */
  YYSYMBOL_refineStatement = 264,          /* refineStatement  */
  YYSYMBOL_265_31 = 265,                   /* $@31  */
  YYSYMBOL_refineSpec = 266,               /* refineSpec  */
  YYSYMBOL_refineSubstatement = 267,       /* refineSubstatement  */
  YYSYMBOL_refine_0n = 268,                /* refine_0n  */
  YYSYMBOL_refine = 269,                   /* refine  */
  YYSYMBOL_augmentStatement = 270,         /* augmentStatement  */
  YYSYMBOL_271_32 = 271,                   /* $@32  */
  YYSYMBOL_augmentSubstatement_0n = 272,   /* augmentSubstatement_0n  */
  YYSYMBOL_augmentSubstatement = 273,      /* augmentSubstatement  */
  YYSYMBOL_whenStatement = 274,            /* whenStatement  */
  YYSYMBOL_rpcStatement = 275,             /* rpcStatement  */
  YYSYMBOL_276_33 = 276,                   /* $@33  */
  YYSYMBOL_rpcSpec = 277,                  /* rpcSpec  */
  YYSYMBOL_rpcSubstatement_0n = 278,       /* rpcSubstatement_0n  */
  YYSYMBOL_rpcSubstatement = 279,          /* rpcSubstatement  */
  YYSYMBOL_inputStatement = 280,           /* inputStatement  */
  YYSYMBOL_281_34 = 281,                   /* $@34  */
  YYSYMBOL_inputOutputSubstatement_0n = 282, /* inputOutputSubstatement_0n  */
  YYSYMBOL_inputOutputSubstatement = 283,  /* inputOutputSubstatement  */
  YYSYMBOL_outputStatement = 284,          /* outputStatement  */
  YYSYMBOL_285_35 = 285,                   /* $@35  */
  YYSYMBOL_notificationStatement = 286,    /* notificationStatement  */
  YYSYMBOL_287_36 = 287,                   /* $@36  */
  YYSYMBOL_notificationSpec = 288,         /* notificationSpec  */
  YYSYMBOL_notificationSubstatement_0n = 289, /* notificationSubstatement_0n  */
  YYSYMBOL_notificationSubstatement = 290, /* notificationSubstatement  */
  YYSYMBOL_deviationStatement = 291,       /* deviationStatement  */
  YYSYMBOL_292_37 = 292,                   /* $@37  */
  YYSYMBOL_deviationSubstatement_0n = 293, /* deviationSubstatement_0n  */
  YYSYMBOL_deviationSubstatement = 294,    /* deviationSubstatement  */
  YYSYMBOL_deviateNotSupported = 295,      /* deviateNotSupported  */
  YYSYMBOL_deviateAddStatement = 296,      /* deviateAddStatement  */
  YYSYMBOL_297_38 = 297,                   /* $@38  */
  YYSYMBOL_deviateAddSpec = 298,           /* deviateAddSpec  */
  YYSYMBOL_deviateAddSubstatement_0n = 299, /* deviateAddSubstatement_0n  */
  YYSYMBOL_deviateAddSubstatement = 300,   /* deviateAddSubstatement  */
  YYSYMBOL_deviateDeleteStatement = 301,   /* deviateDeleteStatement  */
  YYSYMBOL_302_39 = 302,                   /* $@39  */
  YYSYMBOL_deviateDeleteSpec = 303,        /* deviateDeleteSpec  */
  YYSYMBOL_deviateDeleteSubstatement_0n = 304, /* deviateDeleteSubstatement_0n  */
  YYSYMBOL_deviateDeleteSubstatement = 305, /* deviateDeleteSubstatement  */
  YYSYMBOL_deviateReplaceStatement = 306,  /* deviateReplaceStatement  */
  YYSYMBOL_307_40 = 307,                   /* $@40  */
  YYSYMBOL_deviateReplaceSpec = 308,       /* deviateReplaceSpec  */
  YYSYMBOL_deviateReplaceSubstatement_0n = 309, /* deviateReplaceSubstatement_0n  */
  YYSYMBOL_deviateReplaceSubstatement = 310, /* deviateReplaceSubstatement  */
  YYSYMBOL_anyXMLStatement = 311,          /* anyXMLStatement  */
  YYSYMBOL_312_41 = 312,                   /* $@41  */
  YYSYMBOL_anyXMLSpec = 313,               /* anyXMLSpec  */
  YYSYMBOL_anyXMLSubstatement_0n = 314,    /* anyXMLSubstatement_0n  */
  YYSYMBOL_anyXMLSubstatement = 315,       /* anyXMLSubstatement  */
  YYSYMBOL_extensionStatement = 316,       /* extensionStatement  */
  YYSYMBOL_317_42 = 317,                   /* $@42  */
  YYSYMBOL_extensionStatementBody = 318,   /* extensionStatementBody  */
  YYSYMBOL_extensionSubstatement_0n = 319, /* extensionSubstatement_0n  */
  YYSYMBOL_extensionSubstatement = 320,    /* extensionSubstatement  */
  YYSYMBOL_argumentStatement = 321,        /* argumentStatement  */
  YYSYMBOL_322_43 = 322,                   /* $@43  */
  YYSYMBOL_argumentStatementBody = 323,    /* argumentStatementBody  */
  YYSYMBOL_yinElementOptional = 324,       /* yinElementOptional  */
  YYSYMBOL_unitsStatement = 325,           /* unitsStatement  */
  YYSYMBOL_defaultStatement = 326,         /* defaultStatement  */
  YYSYMBOL_prefix = 327,                   /* prefix  */
  YYSYMBOL_identifierRef = 328,            /* identifierRef  */
  YYSYMBOL_identifierStr = 329,            /* identifierStr  */
  YYSYMBOL_booleanValue = 330,             /* booleanValue  */
  YYSYMBOL_string = 331                    /* string  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  81
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1593

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  95
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  237
/* YYNRULES -- Number of rules.  */
#define YYNRULES  617
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  941

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   346


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    94,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    92,     2,    93,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   578,   578,   580,   584,   583,   623,   622,   662,   673,
     675,   678,   680,   682,   685,   687,   690,   692,   694,   696,
     699,   702,   705,   710,   709,   722,   724,   727,   729,   732,
     734,   737,   739,   742,   744,   746,   748,   750,   752,   754,
     756,   758,   760,   763,   765,   767,   769,   771,   773,   775,
     778,   780,   782,   784,   787,   798,   809,   817,   825,   833,
     844,   855,   860,   865,   871,   895,   901,   900,   914,   916,
     920,   922,   924,   931,   930,   955,   957,   961,   960,   976,
     978,   985,   984,   996,   998,  1004,  1006,  1009,  1011,  1013,
    1015,  1017,  1025,  1024,  1034,  1036,  1042,  1044,  1047,  1049,
    1051,  1053,  1056,  1055,  1075,  1077,  1081,  1083,  1085,  1087,
    1089,  1091,  1095,  1094,  1109,  1111,  1117,  1119,  1121,  1123,
    1125,  1127,  1129,  1133,  1136,  1139,  1141,  1145,  1144,  1156,
    1163,  1165,  1168,  1170,  1174,  1173,  1187,  1186,  1197,  1199,
    1203,  1202,  1220,  1222,  1228,  1230,  1233,  1235,  1237,  1239,
    1242,  1248,  1250,  1256,  1258,  1261,  1263,  1265,  1267,  1270,
    1277,  1284,  1286,  1289,  1293,  1300,  1311,  1313,  1316,  1320,
    1328,  1330,  1334,  1333,  1349,  1351,  1357,  1359,  1362,  1364,
    1366,  1368,  1371,  1396,  1398,  1401,  1403,  1408,  1410,  1416,
    1418,  1420,  1422,  1424,  1426,  1428,  1430,  1434,  1433,  1445,
    1447,  1453,  1455,  1459,  1461,  1463,  1465,  1467,  1469,  1471,
    1473,  1475,  1477,  1479,  1482,  1487,  1494,  1493,  1507,  1509,
    1515,  1517,  1520,  1522,  1524,  1528,  1527,  1545,  1547,  1551,
    1553,  1555,  1557,  1559,  1561,  1563,  1567,  1566,  1584,  1586,
    1590,  1592,  1594,  1596,  1598,  1600,  1602,  1604,  1606,  1610,
    1623,  1622,  1634,  1633,  1647,  1646,  1657,  1659,  1665,  1667,
    1670,  1672,  1674,  1676,  1678,  1680,  1682,  1684,  1688,  1687,
    1699,  1705,  1707,  1710,  1712,  1714,  1716,  1719,  1726,  1733,
    1741,  1747,  1755,  1754,  1771,  1773,  1776,  1778,  1780,  1782,
    1784,  1786,  1788,  1790,  1794,  1793,  1810,  1812,  1815,  1817,
    1819,  1821,  1823,  1825,  1827,  1829,  1831,  1835,  1834,  1848,
    1850,  1853,  1855,  1857,  1859,  1861,  1863,  1865,  1867,  1869,
    1871,  1873,  1875,  1878,  1888,  1898,  1909,  1917,  1928,  1927,
    1938,  1940,  1946,  1948,  1951,  1953,  1955,  1957,  1959,  1961,
    1965,  1964,  1978,  1980,  1982,  1984,  1986,  1989,  1991,  1997,
    1999,  2002,  2004,  2006,  2008,  2010,  2012,  2016,  2018,  2020,
    2022,  2024,  2026,  2031,  2030,  2044,  2046,  2049,  2051,  2053,
    2055,  2057,  2059,  2063,  2062,  2075,  2082,  2084,  2087,  2089,
    2091,  2093,  2095,  2097,  2099,  2104,  2103,  2117,  2119,  2125,
    2127,  2129,  2131,  2133,  2135,  2137,  2139,  2141,  2143,  2145,
    2147,  2152,  2151,  2187,  2189,  2192,  2194,  2196,  2198,  2200,
    2202,  2204,  2208,  2216,  2215,  2226,  2228,  2234,  2236,  2239,
    2241,  2243,  2245,  2247,  2249,  2251,  2253,  2257,  2256,  2282,
    2284,  2287,  2289,  2291,  2295,  2294,  2322,  2321,  2332,  2334,
    2341,  2343,  2346,  2348,  2350,  2352,  2354,  2356,  2358,  2362,
    2361,  2375,  2377,  2379,  2381,  2383,  2385,  2387,  2389,  2392,
    2398,  2406,  2405,  2416,  2418,  2424,  2426,  2428,  2430,  2432,
    2434,  2436,  2438,  2440,  2442,  2446,  2445,  2456,  2458,  2464,
    2466,  2468,  2470,  2472,  2474,  2477,  2476,  2487,  2489,  2495,
    2497,  2499,  2501,  2503,  2505,  2507,  2509,  2511,  2516,  2515,
    2526,  2528,  2534,  2536,  2539,  2541,  2543,  2545,  2547,  2551,
    2550,  2561,  2563,  2566,  2568,  2571,  2573,  2575,  2577,  2581,
    2580,  2592,  2594,  2597,  2599,  2604,  2610,  2617,  2624,  2627,
    2629,  2631,  2633,  2635,  2637,  2639,  2641,  2643,  2646,  2647,
    2647,  2647,  2647,  2647,  2647,  2647,  2647,  2648,  2648,  2648,
    2648,  2648,  2648,  2648,  2648,  2649,  2649,  2649,  2649,  2649,
    2649,  2649,  2649,  2650,  2650,  2650,  2650,  2650,  2650,  2650,
    2650,  2651,  2651,  2651,  2651,  2651,  2651,  2651,  2651,  2651,
    2652,  2652,  2652,  2652,  2652,  2652,  2652,  2652,  2652,  2653,
    2653,  2653,  2653,  2653,  2653,  2653,  2653,  2654,  2654,  2654,
    2654,  2654,  2654,  2654,  2654,  2655,  2655,  2655,  2655,  2655,
    2655,  2658,  2663,  2669,  2671,  2673,  2675,  2677
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "augmentKeyword",
  "belongs_toKeyword", "choiceKeyword", "configKeyword", "contactKeyword",
  "containerKeyword", "defaultKeyword", "descriptionKeyword",
  "fractionDigitsKeyword", "enumKeyword", "error_app_tagKeyword",
  "error_messageKeyword", "extensionKeyword", "groupingKeyword",
  "importKeyword", "includeKeyword", "keyKeyword", "leafKeyword",
  "leaf_listKeyword", "lengthKeyword", "listKeyword", "mandatoryKeyword",
  "max_elementsKeyword", "min_elementsKeyword", "moduleKeyword",
  "submoduleKeyword", "mustKeyword", "namespaceKeyword",
  "ordered_byKeyword", "organizationKeyword", "prefixKeyword",
  "rangeKeyword", "referenceKeyword", "patternKeyword", "revisionKeyword",
  "statusKeyword", "typeKeyword", "typedefKeyword", "uniqueKeyword",
  "unitsKeyword", "usesKeyword", "valueKeyword", "whenKeyword",
  "bitKeyword", "pathKeyword", "anyXMLKeyword", "deprecatedKeyword",
  "currentKeyword", "obsoleteKeyword", "trueKeyword", "falseKeyword",
  "caseKeyword", "inputKeyword", "outputKeyword", "rpcKeyword",
  "notificationKeyword", "argumentKeyword", "yangversionKeyword",
  "baseKeyword", "deviationKeyword", "deviateKeyword", "featureKeyword",
  "identityKeyword", "ifFeatureKeyword", "positionKeyword",
  "presenceKeyword", "refineKeyword", "requireInstanceKeyword",
  "yinElementKeyword", "notSupportedKeyword", "addKeyword",
  "deleteKeyword", "replaceKeyword", "complexTypeKeyword",
  "extendsKeyword", "abstractKeyword", "instanceKeyword",
  "instanceListKeyword", "instanceTypeKeyword", "identifier",
  "identifierRefArg", "identifierRefArgStr", "dateString", "yangVersion",
  "qString", "uqString", "decimalNumber", "floatNumber", "hexNumber",
  "'{'", "'}'", "';'", "$accept", "yangFile", "moduleStatement", "$@1",
  "submoduleStatement", "$@2", "moduleHeaderStatement_0n",
  "moduleHeaderStatement0_n", "moduleHeaderStatement",
  "moduleMetaStatement_0n", "moduleMetaStatement",
  "submoduleHeaderStatement", "belongsToStatement", "$@3",
  "linkageStatement_0n", "linkageStatement", "revisionStatement_0n",
  "bodyStatement_0n", "bodyStatement", "dataDefStatement",
  "commonStatement", "organizationStatement", "contactStatement",
  "descriptionStatement", "referenceStatement", "statusStatement",
  "namespaceStatement", "yangVersionStatement", "status",
  "prefixStatement", "revisionStatement", "$@4", "revisionSubstatement_On",
  "revisionSubstatement", "date", "importStatement", "$@5",
  "optionalRevision", "includeStatement", "$@6", "includeStatementBody",
  "featureStatement", "$@7", "featureSpec", "featureSubstatement_0n",
  "featureSubstatement", "ifFeatureStatement", "identityStatement", "$@8",
  "identitySpec", "identitySubstatement_0n", "identitySubstatement",
  "typedefStatement", "$@9", "typedefSubstatement_0n",
  "typedefSubstatement", "typeStatement", "$@10",
  "optionalTypeBodyStatements", "typeBodyStmts", "numRestriction", "range",
  "$@11", "fractionDigitsStatement", "stringRestriction_0n",
  "stringRestriction", "length", "$@12", "pattern", "$@13", "enumSpec",
  "enum", "$@14", "enumSubstatementSpec", "enumSubstatement_0n",
  "enumSubstatement", "valueStatement", "optionalRestrictionSpec",
  "restrictionSpec_0n", "restrictionSpec", "errorMessageStatement",
  "errorAppTagStatement", "leafrefSpec", "path",
  "requireInstanceStatement", "identityrefSpec", "baseStatement",
  "bitsSpec", "bitsStatement", "$@15", "bitsSubstatementSpec",
  "bitsSubstatement_0n", "bitsSubstatement", "positionStatement",
  "unionSpec", "stmtEnd", "stmtSep", "unknownStatement0_n",
  "complexTypeStatement", "$@16", "complexTypeSpec",
  "complexTypeSubstatement_0n", "complexTypeSubstatement",
  "abstractStatement", "extendsStatement", "$@17", "extendsStatementSpec",
  "extendsSubstatement_0n", "extendsSubstatement", "instanceStatement",
  "$@18", "instanceSubstatement_0n", "instanceSubstatement",
  "instanceListStatement", "$@19", "instanceListSubstatement_0n",
  "instanceListSubstatement", "instanceTypeStatement", "unknownStatement",
  "$@20", "$@21", "containerStatement", "$@22", "containerSpec",
  "containerSubstatement_0n", "containerSubstatement", "mustStatement",
  "$@23", "mustSubstatement_0n", "mustSubstatement", "presenceStatement",
  "configStatement", "mandatoryStatement", "leafStatement", "$@24",
  "leafSubstatement_0n", "leafSubstatement", "leaf_listStatement", "$@25",
  "leaf_listSubstatement_0n", "leaf_listSubstatement", "listStatement",
  "$@26", "listSubstatement_0n", "listSubstatement",
  "max_elementsStatement", "min_elementsStatement", "ordered_byStatement",
  "keyStatement", "uniqueStatement", "choiceStatement", "$@27",
  "choiceSpec", "choiceSubstatement_0n", "choiceSubstatement",
  "caseStatement", "$@28", "caseSpec", "caseSubstatement_0n",
  "caseSubstatement", "caseDataDef", "groupingStatement", "$@29",
  "groupingSubstatement_0n", "groupingSubstatement", "usesStatement",
  "$@30", "usesSubstatement_0n", "usesSubstatement", "refineStatement",
  "$@31", "refineSpec", "refineSubstatement", "refine_0n", "refine",
  "augmentStatement", "$@32", "augmentSubstatement_0n",
  "augmentSubstatement", "whenStatement", "rpcStatement", "$@33",
  "rpcSpec", "rpcSubstatement_0n", "rpcSubstatement", "inputStatement",
  "$@34", "inputOutputSubstatement_0n", "inputOutputSubstatement",
  "outputStatement", "$@35", "notificationStatement", "$@36",
  "notificationSpec", "notificationSubstatement_0n",
  "notificationSubstatement", "deviationStatement", "$@37",
  "deviationSubstatement_0n", "deviationSubstatement",
  "deviateNotSupported", "deviateAddStatement", "$@38", "deviateAddSpec",
  "deviateAddSubstatement_0n", "deviateAddSubstatement",
  "deviateDeleteStatement", "$@39", "deviateDeleteSpec",
  "deviateDeleteSubstatement_0n", "deviateDeleteSubstatement",
  "deviateReplaceStatement", "$@40", "deviateReplaceSpec",
  "deviateReplaceSubstatement_0n", "deviateReplaceSubstatement",
  "anyXMLStatement", "$@41", "anyXMLSpec", "anyXMLSubstatement_0n",
  "anyXMLSubstatement", "extensionStatement", "$@42",
  "extensionStatementBody", "extensionSubstatement_0n",
  "extensionSubstatement", "argumentStatement", "$@43",
  "argumentStatementBody", "yinElementOptional", "unitsStatement",
  "defaultStatement", "prefix", "identifierRef", "identifierStr",
  "booleanValue", "string", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-729)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
       3,  1350,  1350,    18,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,   -67,   -50,   490,   490,  1350,  1268,    97,  1350,
    1350,  1268,  1182,     8,  -729,   490,   490,   490,   490,   490,
     490,   490,    19,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,   -10,   -10,  -729,  -729,   -10,  -729,
    -729,  -729,  -729,   -10,  -729,  -729,  1182,  1350,   -25,  -729,
    -729,     8,   490,   490,   490,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  1350,  -729,   490,   490,    64,    93,   490,  -729,
    -729,  -729,   -11,    36,  -729,  -729,   -10,   -10,   -10,  -729,
     -10,   163,  -729,  -729,  -729,  -729,  -729,   163,    72,   134,
     490,  -729,  -729,   490,  -729,  -729,    66,   490,   490,  -729,
    -729,  -729,  -729,  1350,  1350,   393,  -729,   490,   490,    70,
     393,   490,   490,  1421,    59,  -729,  1527,  1457,  -729,  -729,
    1182,  1182,  1182,  1182,   490,   128,  -729,  -729,  -729,  -729,
    -729,  -729,   490,   128,  -729,  -729,  1350,  1350,  1350,  1182,
    1350,  1350,  1350,  1182,  1182,   158,  1350,  1268,  1350,  1268,
    1182,  -729,  -729,  -729,  -729,  -729,  -729,    75,   490,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,    98,   490,  1182,   123,   170,  1182,
    -729,  -729,  -729,  -729,  -729,  -729,   121,   490,  -729,  -729,
    -729,  -729,  -729,  1182,  1182,  -729,  -729,  -729,   125,   490,
    -729,  -729,  -729,  -729,  -729,  -729,   135,   103,   -10,   -10,
     -10,   -10,  -729,   147,   806,   490,   207,   872,  -729,  -729,
    -729,   -10,  -729,  -729,  -729,   150,   -10,  -729,  -729,  -729,
     -10,  -729,   180,  -729,   -10,  -729,  -729,  1421,  -729,    59,
    -729,   -10,   -10,   -10,   -10,   -10,  -729,  1527,   -10,   -10,
    -729,  1457,   490,   490,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,   183,  1350,  1350,  1350,  1182,  1350,  1350,  -729,   490,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,   490,  -729,   106,   127,   191,  -729,   201,   214,   237,
    -729,   242,  -729,  -729,   259,  -729,   266,   167,  -729,   176,
    -729,  -729,   285,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,   207,   128,  -729,   290,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,   293,   490,  -729,  -729,   490,  -729,  -729,
     490,   490,   490,   490,  -729,   490,  -729,   490,  -729,  -729,
     490,  -729,  -729,   490,   490,   490,   338,   490,   190,   205,
     270,   356,   289,   298,  -729,  -729,  1491,  -729,  -729,  -729,
    -729,   253,  -729,    86,  -729,  -729,   490,   128,  -729,  -729,
    -729,   490,  -729,  -729,   490,  -729,  -729,   490,  -729,  -729,
     490,   490,  -729,  -729,   490,  -729,  -729,  1080,  1182,  -729,
    -729,  -729,  -729,   359,   490,  -729,  -729,  -729,  -729,  1039,
    1100,  1088,   950,  1182,  1182,  -729,  -729,  -729,  -729,  -729,
     490,    48,  -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,
    -729,    85,   360,   504,  -729,   979,   365,   196,  -729,  -729,
    -729,   136,  -729,  -729,  1182,  1350,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,  -729,   -10,
    -729,  1491,  -729,  -729,  -729,  -729,  -729,  -729,  -729,   490,
    1268,  1182,  -729,  -729,  -729,  -729,  -729,  -729,   490,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,
    -729,  -729,  -729,  1182,  -729,  -729,  -729,  -729,  -729,  -729,
     490,  -729,  -729,  -729,  -729,  -729,  -729,  -729,   -10,   -10,
    -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,   490,
    -729,  -729,  -729,  -729,  -729,  -729,   490,   314,   803,  1018,
      43,  -729,  -729,   182,   490,  -729,  -729,  -729,  -729,   333,
     353,   -10,  -729,  -729,  -729,  -729,  -729,  -729,   -10,  -729,
    -729,   -10,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    1350,  -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,   490,   304,  -729,
    -729,  -729,  -729,   490,  -729,  -729,  -729,  -729,  -729,   490,
    -729,  1268,  -729,  -729,  -729,  -729,   490,  -729,  -729,   321,
     335,  -729,  -729,  -729,  -729,   357,   374,  -729,  -729,   490,
    -729,   342,   343,   346,  -729,  -729,   -10,  -729,   490,  -729,
    -729,   490,  -729,  -729,   370,   490,   490,   377,   490,  -729,
    -729,   490,  -729,  -729,   490,  -729,  -729,  -729,  -729,   615,
     490,  -729,  -729,  1132,  1132,  -729,  -729,  -729,  -729,   740,
    1182,  1182,  1182,   385,  1182,   199,   490,   378,  -729,   490,
     456,   -12,   479,   490,  -729,   490,   490,  -729,   490,   448,
     490,   462,   424,  -729,  -729,  -729,   599,   490,   901,   148,
      11,   187,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,   490,  -729,  -729,  -729,  -729,   -10,  -729,  -729,  -729,
     -10,  -729,  -729,   -10,  -729,  -729,   493,   490,  1182,  1182,
    -729,  -729,  -729,   490,  -729,   436,     4,   436,   490,  -729,
     490,   292,   414,  -729,   490,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,   490,  -729,  -729,  -729,  -729,  -729,
     490,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,   490,
    -729,  -729,  -729,  -729,   390,   394,   411,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,   490,   490,   490,   490,  -729,  -729,
     -10,   -10,  -729,  -729,  -729,  -729,  -729,   490,  -729,  -729,
     490,  -729,  -729,   490,  -729,  -729,   394,   394,  -729,  -729,
    -729,  -729,   490,   490,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,    29,   409,   243,  1182,  -729,  -729,  -729,  -729,   490,
    -729,  -729,  -729,  -729,   490,  -729,  -729,  1182,  -729,  -729,
    -729,  -729,   490,  -729,   -10,  -729,  -729,   -10,  -729,  -729,
    -729
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     2,     3,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   538,     4,
       6,     1,     0,     0,   187,   187,     0,     0,     0,     0,
       0,     0,   250,     9,   188,   189,   189,   189,   189,   189,
     189,   189,     0,   197,   532,   533,   534,   535,   536,   537,
     529,   530,   216,   531,     0,     0,   225,   236,     0,   616,
     617,   613,   614,     0,   615,   252,     0,     0,     0,    25,
       8,     9,   187,   187,   187,   191,   195,   196,   192,   193,
     194,   190,     0,    25,   187,   187,     0,     0,   189,   185,
     214,   215,     0,     0,   249,   251,     0,     0,     0,   528,
       0,    14,    10,    12,    11,    13,    23,    14,    22,     0,
     187,   199,   198,   187,   218,   217,     0,   187,   187,   253,
      59,    64,    60,     0,     0,    29,    26,   187,   187,     0,
      29,   187,   187,   201,   220,   186,   227,   238,    73,    77,
       0,     0,     0,     0,   187,    31,    16,    17,    18,    19,
      28,    27,   187,    31,    20,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   205,   211,   213,   212,   204,   207,     0,   187,    43,
     206,    44,    45,    46,   209,   208,    47,   203,    49,   210,
      48,   222,   224,   223,     0,   187,     0,     0,     0,     0,
     231,   230,    50,    52,    51,   229,     0,   187,   232,    53,
     234,   235,   233,     0,     0,   242,   241,   240,     0,   187,
     243,   246,   247,   248,   245,   244,     0,     0,     0,     0,
       0,     0,    15,     0,     0,   187,     0,     0,   328,   254,
     363,     0,   282,   294,   307,   268,     0,    61,    62,    63,
       0,   102,   373,   498,     0,   385,   200,   201,   219,   220,
     401,     0,     0,     0,     0,     0,   226,   227,     0,     0,
     237,   238,   187,   187,    79,    78,    55,    56,    54,    57,
      72,    66,     0,     0,     0,     0,     0,     0,     5,   187,
      38,    34,    35,    36,    37,    39,    40,    41,    42,    33,
      30,   187,     7,     0,     0,     0,   326,     0,     0,     0,
     270,     0,   325,    58,     0,   375,     0,     0,    91,     0,
     202,   221,     0,   278,   279,   280,   281,   412,   228,   323,
     324,   239,     0,    75,    65,     0,   509,   413,   436,   449,
      81,    92,    32,     0,   187,   330,   329,   187,   256,   255,
     187,   187,   187,   187,   271,   187,   376,   187,   500,   499,
     187,   387,   386,   187,   187,   187,     0,   187,     0,     0,
       0,     0,     0,     0,    24,   332,   258,   365,   284,   296,
     309,     0,   104,     0,   502,   390,   187,    75,    76,    80,
      68,   187,   512,   510,   187,   415,   414,   187,   438,   437,
     187,   187,    83,    82,   187,    94,    93,     0,     0,   262,
     261,   260,   267,     0,   187,   264,   266,   263,   265,     0,
       0,     0,     0,     0,     0,   269,   275,   276,   273,   274,
     187,     0,   374,   378,   379,   380,   382,   187,   383,   384,
     381,     0,     0,   389,   403,     0,     0,     0,   513,   417,
     440,     0,    85,    96,     0,     0,   331,   334,   337,   342,
     338,   343,   344,   345,   187,   339,   336,   346,   335,     0,
     257,   258,   364,   370,   368,   369,   367,   372,   371,   187,
       0,     0,   283,   289,   286,   291,   288,   290,   187,   293,
     287,   292,   295,   299,   301,   300,   298,   187,   304,   305,
     306,   303,   302,     0,   308,   318,   312,   322,   319,   311,
     187,   313,   314,   315,   316,   317,   320,   321,     0,     0,
     272,   103,   111,   110,   109,   187,   106,   107,   108,   377,
     501,   504,   506,   507,   508,   505,   187,   388,   395,   396,
     392,   393,   394,   398,   400,   399,   187,   397,   402,   410,
     407,   408,   409,   406,    43,    44,    45,    46,   411,   187,
     405,    48,    74,    67,    70,    71,   187,     0,     0,     0,
       0,   453,   454,     0,   187,   455,   456,   457,   458,     0,
       0,     0,   340,   333,   277,   259,   366,   112,     0,   285,
     297,     0,   310,   160,   159,   105,   503,   391,   404,    69,
       0,   511,   517,   518,   516,   187,   515,   427,   434,   416,
     420,   421,   422,   419,   423,   424,   187,   425,   426,   439,
     446,   443,   444,   445,   442,   448,   447,   187,     0,   461,
     475,   485,   450,   187,   451,    84,    89,    90,    88,   187,
      87,     0,    95,   100,   101,    99,   187,    98,   527,     0,
       0,   526,   327,   519,   514,     0,     0,   418,   441,   187,
     459,     0,     0,     0,   452,    86,     0,    97,   187,   347,
     341,   187,   114,   113,     0,   187,   187,     0,   187,   463,
     462,   187,   477,   476,   187,   487,   486,   169,   349,   130,
     187,   522,   520,     0,     0,   460,   465,   479,   489,     0,
       0,     0,     0,     0,     0,     0,   187,     0,   116,   187,
     125,   117,   118,   187,   119,   187,   187,   120,   187,   121,
     187,   122,   523,   431,   433,   432,     0,   187,     0,     0,
       0,     0,   348,   351,   353,   352,   355,   357,   358,   359,
     360,   187,   356,   362,   354,   361,     0,   140,   127,   172,
       0,   611,   612,     0,   183,   115,   126,   187,     0,     0,
     131,   132,   133,   187,   138,   161,     0,   166,   187,   170,
     187,     0,     0,   428,   187,   429,   435,   464,   468,   471,
     472,   474,   473,   469,   187,   467,   470,   478,   482,   483,
     187,   481,   484,   488,   491,   494,   495,   497,   496,   187,
     492,   493,   350,   129,     0,     0,     0,   164,   165,   123,
     124,   134,   136,   139,   187,   187,   187,   187,   171,   184,
       0,     0,   521,   430,   466,   480,   490,   187,   142,   141,
     187,   151,   128,   187,   174,   173,     0,     0,   162,   163,
     168,   167,   187,   187,   144,   153,   176,   135,   137,   524,
     525,     0,     0,     0,     0,   143,   148,   149,   147,   187,
     146,   152,   155,   156,   187,   157,   158,     0,   175,   179,
     180,   181,   187,   178,     0,   145,   154,     0,   177,   150,
     182
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -729,  -729,  -729,  -729,  -729,  -729,  -729,   381,  -729,   348,
    -729,  -729,   347,  -729,   375,  -729,   327,   307,  -729,    53,
     156,  -729,  -729,   -46,    40,  -131,  -729,   -68,  -729,  -291,
    -367,  -729,  -729,  -729,  -729,  -729,  -729,    76,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,   272,  -729,  -729,  -729,
    -729,  -729,   -32,  -729,  -729,  -729,  -480,  -729,  -729,  -729,
    -729,  -248,  -729,  -292,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -247,  -729,  -729,  -729,  -729,  -729,  -495,  -729,  -729,
    -386,  -376,  -729,  -289,  -690,  -729,  -728,  -729,  -241,  -729,
    -729,  -729,  -729,  -729,  -729,   -86,   -85,   379,  -729,  -729,
    -729,   223,  -729,  -729,  -729,  -729,  -729,   225,  -729,  -729,
    -729,   215,  -729,  -729,  -729,   217,  -729,  -729,  -729,  -729,
    -729,  -461,  -729,  -729,    15,  -729,   -71,  -729,  -729,  -729,
      47,  -484,  -458,  -455,  -729,  -729,  -729,  -451,  -729,  -729,
    -729,  -450,  -729,  -729,  -729,  -468,  -404,  -195,    71,  -348,
    -729,  -729,  -729,  -729,  -729,    49,  -729,  -729,  -729,  -729,
    -729,   262,  -729,  -729,  -729,  -207,  -729,  -729,  -729,   114,
    -729,  -729,  -729,  -729,  -729,  -189,  -729,  -729,  -729,  -164,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -194,  -380,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,   -72,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -439,  -729,  -729,  -729,
    -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,  -729,
    -435,  -476,  -729,   -84,    74,  -729,   -90
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     3,     4,    82,     5,    83,   129,   130,   131,   185,
     204,   143,   144,   189,   161,   186,   205,   294,   349,   783,
     261,   206,   207,   262,   263,   264,   132,   133,   310,   134,
     295,   395,   507,   626,   341,   187,   286,   426,   188,   287,
     335,   351,   432,   463,   639,   699,   235,   352,   433,   466,
     640,   706,   784,   374,   491,   585,   545,   710,   733,   767,
     768,   769,   865,   770,   771,   820,   821,   896,   822,   897,
     772,   773,   864,   889,   911,   919,   920,   892,   912,   924,
     488,   489,   774,   775,   776,   777,   707,   779,   780,   866,
     895,   913,   932,   933,   781,   150,    93,    94,    95,   146,
     172,   237,   238,    96,    97,   147,   175,   254,   255,    98,
     152,   266,   267,    99,   153,   278,   279,   100,   101,   123,
     156,   239,   364,   409,   473,   474,   240,   371,   441,   490,
     476,   269,   270,   241,   367,   480,   548,   242,   368,   481,
     557,   243,   369,   482,   570,   281,   282,   244,   245,   575,
     246,   363,   406,   467,   524,   525,   709,   730,   759,   801,
     802,   785,   365,   479,   539,   248,   376,   443,   497,   249,
     379,   422,   502,   503,   606,   271,   382,   505,   619,   272,
     356,   429,   456,   628,   676,   677,   715,   786,   787,   678,
     716,   357,   430,   459,   629,   687,   358,   431,   633,   634,
     635,   636,   721,   740,   789,   844,   637,   722,   743,   790,
     850,   638,   723,   746,   791,   859,   250,   377,   419,   501,
     596,   359,   428,   453,   627,   665,   666,   734,   752,   832,
     550,   528,   158,   124,   113,   813,   125
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     102,   555,   283,   112,   551,   361,   519,   118,   284,   520,
     818,   586,   521,   558,   571,   588,   522,   523,    81,   602,
     514,   778,   547,   142,   819,    84,   425,   607,   527,   151,
       1,     2,   154,   285,   145,   604,   157,   155,   126,   201,
     223,   127,    85,   594,   614,   603,   562,   163,   164,   165,
     615,   764,   563,   541,   616,   617,   587,   514,   201,   168,
     169,   160,   234,   253,   203,   701,   621,   225,   128,   201,
     179,   180,   181,   914,   182,    79,    80,   559,   572,   128,
     425,   177,   148,   203,   149,   193,   225,   540,   194,   256,
     541,   257,   196,   197,   203,   201,   201,   225,   876,   605,
     191,   424,   210,   211,   847,   355,   214,   215,   355,   258,
     288,   289,   290,   291,   223,   688,   689,   690,   691,   292,
     203,   203,   915,   225,   225,   268,   280,   296,   178,   301,
     259,   259,   128,   305,   306,   874,   283,   877,   142,   208,
     315,   581,   284,   312,   208,   314,   201,   232,   251,   114,
     115,   229,   229,   317,   257,   230,   170,   514,   171,   195,
     103,   236,   212,   116,   117,   293,   320,   285,   316,   325,
     319,   203,   258,   273,   274,   321,   322,   223,   590,   492,
     183,   184,   327,   328,   329,   173,   234,   174,   253,   563,
     541,   318,   201,   257,   331,   333,   514,   334,   404,   630,
     405,   159,   336,   337,   338,   339,   201,   307,   308,   309,
     360,   258,   273,   274,   326,   366,   166,   203,   330,   407,
     372,   408,   323,   324,   373,   209,   540,   332,   378,   541,
     209,   203,   340,   233,   252,   383,   384,   385,   386,   387,
     127,   837,   389,   390,   370,   630,   231,   392,   393,   260,
     275,   811,   812,   201,   499,   399,   268,   198,   199,   417,
     280,   418,   353,   201,   402,   353,   483,   484,   420,   766,
     421,   232,   478,   251,   375,   692,   403,   394,   203,   500,
     853,   225,   451,   410,   452,   236,   560,   573,   203,   623,
     298,   299,   300,   411,   302,   303,   304,   454,   797,   455,
     311,   830,   313,   526,   798,   839,   412,   855,   799,   800,
     927,   854,   495,   846,   852,   861,   549,   561,   577,   435,
     805,   841,   436,   857,   201,   437,   438,   439,   440,   413,
     442,   840,   444,   856,   414,   445,   928,   595,   446,   447,
     448,   620,   450,   201,   880,   881,   485,   350,   536,   203,
     350,   415,   225,   276,   845,   851,   860,   233,   416,   252,
     584,   504,   457,   201,   458,   475,   508,   478,   203,   509,
     231,   225,   510,   660,   612,   511,   512,   423,   529,   513,
     260,   461,   427,   462,   275,   842,   434,   858,   203,   531,
     464,   225,   465,   578,   579,   486,   719,   493,   720,   229,
     200,   907,   908,   201,   472,   580,   834,   661,   834,   546,
     556,   569,   589,   728,   701,   729,   396,   397,   398,   201,
     400,   401,   483,   484,   641,   202,   695,   731,   203,   732,
     593,   449,   600,   534,   738,   741,   739,   742,   744,   643,
     745,   843,   849,   644,   203,   582,   702,   537,   460,   735,
     568,   648,   530,   597,   646,   247,   647,   598,   622,   610,
     475,   624,   750,   649,   751,   631,   736,   809,   265,   277,
     755,   815,   650,   651,   135,   136,   137,   138,   139,   140,
     141,   487,   887,   494,   888,   652,   890,   276,   891,   469,
     762,   761,   653,   654,   763,   831,   664,   672,   683,   472,
     655,   540,   921,   893,   760,   894,   765,   882,   698,   705,
     257,   656,   162,   514,   201,   190,   192,   213,   167,   535,
     297,   657,   817,   506,   869,   823,   925,   176,   258,   273,
     274,   583,   533,   223,   658,   565,   926,   875,   828,   203,
     380,   659,   388,   599,   381,   611,   645,   625,   391,   694,
     601,   632,   803,   574,   618,   708,   354,   498,   609,   354,
     788,   693,   711,     0,     0,   712,    86,    87,    88,    89,
      90,    91,   468,    92,     0,     0,     0,     0,     0,   247,
     714,   662,   670,   681,   469,     0,     0,   631,     0,   642,
       0,   717,   470,   696,   703,   804,   674,   685,     0,   265,
       0,     0,   718,   277,   216,     0,     0,   217,   724,     0,
       0,     0,     0,     0,   725,   218,     0,   726,     0,   220,
     221,   727,   222,   517,     0,     0,   760,   761,   795,     0,
       0,     0,     0,     0,   737,     0,   543,   553,   566,   226,
     747,     0,   227,   748,     0,     0,   749,   228,     0,   762,
     753,   754,     0,   756,   540,     0,   757,   591,     0,   758,
       0,   763,   764,     0,     0,   782,     0,   663,   671,   682,
     806,   807,   808,   632,   810,     0,   701,     0,     0,   697,
     704,   814,   680,     0,   816,   765,     0,   470,   824,     0,
     825,   826,   833,   827,     0,   829,     0,     0,   477,     0,
       0,     0,   835,     0,     0,     0,     0,     0,   471,     0,
       0,     0,     0,   793,     0,   496,   862,     0,   838,   848,
     863,     0,     0,     0,   867,     0,     0,   868,   871,   872,
       0,     0,   870,     0,   713,     0,     0,     0,   873,   518,
       0,   538,     0,   878,   576,   879,     0,     0,   217,   883,
     201,     0,   544,   554,   567,     0,     0,     0,     0,   884,
     220,   221,     0,   222,     0,   885,     0,     0,     0,     0,
       0,     0,     0,   592,   886,   203,     0,   613,   225,     0,
     918,     0,   931,   227,     0,   259,     0,     0,   228,   898,
     899,   900,   901,   477,   902,   903,     0,     0,     0,   794,
       0,     0,   904,   471,     0,   905,   229,     0,   906,   256,
       0,   216,     0,   201,   217,     0,     0,   909,   910,   218,
       0,   342,   218,     0,   934,     0,   220,   221,     0,   222,
       0,     0,     0,   792,   935,     0,     0,   937,   203,   936,
       0,   225,     0,   226,     0,     0,   226,   938,   939,   227,
       0,   940,     0,     0,   228,     0,     0,     0,   667,   668,
       0,     0,     0,   343,   344,   916,   922,   929,   345,   229,
     346,   347,     0,     0,     0,   256,     0,   216,     0,     0,
     217,     0,     0,     0,     0,     0,     0,   342,   218,     0,
     675,   686,   220,   221,     0,   222,   669,     0,     0,   348,
     673,   684,     0,     0,     0,     0,   216,     0,     0,   217,
       0,   700,   226,     0,     0,   227,     0,   218,     0,     0,
     228,   220,   221,     0,   222,     0,     0,     0,     0,   343,
     344,     0,     0,     0,   345,     0,   346,   347,     0,     0,
       0,   226,     0,     0,   227,     0,     0,     0,     0,   228,
       0,   917,   923,   930,     0,   216,   257,     0,   217,     0,
     201,     0,     0,     0,     0,   362,   218,     0,     0,   219,
     220,   221,     0,   222,     0,   273,   274,     0,     0,   223,
       0,   224,     0,     0,   216,   203,     0,   217,   225,   201,
     226,   563,     0,   227,   836,   259,     0,     0,   228,   220,
     221,     0,   222,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,     0,   229,   225,     0,     0,
       0,     0,   227,   216,   259,     0,   217,   228,   201,     0,
       0,   796,     0,   515,   218,     0,     0,     0,   220,   221,
       0,   222,     0,   564,   216,   229,     0,   217,     0,   201,
       0,     0,     0,   203,     0,   218,   225,     0,   226,   220,
     221,   227,   222,     0,     0,     0,   228,     0,     0,     0,
       0,     0,   608,     0,   203,     0,     0,   225,     0,   226,
       0,     0,   227,     0,   229,     0,   257,   228,   217,   514,
     201,     0,     0,     0,   257,     0,     0,     0,   201,     0,
     220,   221,     0,   222,   258,     0,   257,     0,     0,   514,
     201,   679,     0,   273,   274,   203,     0,   223,   225,   224,
       0,     0,     0,   203,   258,   259,   225,   540,   228,   223,
     541,     0,   532,   259,   515,   203,     0,   216,   225,   540,
     217,     0,   541,     0,     0,   259,   229,     0,   218,     0,
       0,     0,   220,   221,   229,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   229,     0,     0,     0,
       0,     0,   226,   516,     0,   227,     0,     0,     0,     0,
     228,   552,     0,     0,     0,     6,     7,     8,     9,    10,
      11,    12,    13,   542,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,   104,   105,
     106,   107,   108,   109,    78,   110,   111,   119,   120,   121,
     122,     6,     7,     8,     9,    10,    11,    12,    13,     0,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,   104,   105,   106,   107,   108,   109,
      78,   110,   111,     6,     7,     8,     9,    10,    11,    12,
      13,     0,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,   216,     0,     0,   217,
       0,   201,    78,     0,     0,     0,     0,   218,     0,     0,
     219,   220,   221,     0,   222,     0,     0,     0,     0,     0,
     223,     0,   224,     0,     0,     0,   203,     0,     0,   225,
     256,   226,   216,   257,   227,   217,     0,   201,     0,   228,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,     0,   273,   274,     0,     0,   223,   229,   224,     0,
     230,     0,   203,     0,     0,   225,   216,   257,     0,   217,
     227,   201,   259,     0,     0,   228,     0,   218,     0,     0,
       0,   220,   221,     0,   222,     0,     0,     0,     0,     0,
     223,     0,     0,   229,     0,     0,   203,     0,     0,   225,
     256,   226,   216,   257,   227,   217,   259,   201,     0,   228,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   258,     0,     0,     0,     0,   223,   229,     0,   468,
       0,     0,   203,     0,     0,   225,     0,     0,     0,     0,
     227,     0,   259,     0,     0,   228,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   229
};

static const yytype_int16 yycheck[] =
{
      85,   481,   197,    87,   480,   296,   467,    91,   197,   467,
      22,   491,   467,   481,   482,   491,   467,   467,     0,   503,
       9,   749,   480,     4,    36,    92,   393,   503,   467,   115,
      27,    28,   118,   197,   102,   503,   126,   123,    30,    10,
      29,    33,    92,   501,   505,   503,   481,   132,   133,   134,
     505,    47,    41,    42,   505,   505,   491,     9,    10,   144,
     145,    86,   193,   194,    35,    61,   505,    38,    60,    10,
     156,   157,   158,    44,   160,     1,     2,   481,   482,    60,
     447,    92,    92,    35,    94,   170,    38,    39,   173,     3,
      42,     6,   177,   178,    35,    10,    10,    38,   826,   503,
     168,   392,   187,   188,    93,   294,   191,   192,   297,    24,
     200,   201,   202,   203,    29,    72,    73,    74,    75,   204,
      35,    35,    93,    38,    38,   196,   197,   212,    92,   219,
      45,    45,    60,   223,   224,   825,   331,   827,     4,   185,
     230,    93,   331,   227,   190,   229,    10,   193,   194,    52,
      53,    66,    66,   238,     6,    69,    92,     9,    94,    93,
      86,   193,    92,    89,    90,    37,   256,   331,    93,   259,
     255,    35,    24,    25,    26,    52,    53,    29,    93,    93,
      17,    18,   267,   273,   274,    92,   317,    94,   319,    41,
      42,    93,    10,     6,   279,    92,     9,    94,    92,    63,
      94,   127,   288,   289,   290,   291,    10,    49,    50,    51,
     295,    24,    25,    26,    93,   301,   142,    35,    93,    92,
     306,    94,    52,    53,   310,   185,    39,    92,   314,    42,
     190,    35,    85,   193,   194,   321,   322,   323,   324,   325,
      33,    93,   328,   329,    94,    63,   193,   332,   333,   196,
     197,    52,    53,    10,   443,   345,   327,   183,   184,    92,
     331,    94,   294,    10,   349,   297,    13,    14,    92,   749,
      94,   317,   436,   319,    94,    93,   361,    94,    35,   443,
      93,    38,    92,    92,    94,   317,   481,   482,    35,    93,
     216,   217,   218,    92,   220,   221,   222,    92,   759,    94,
     226,   781,   228,   467,   759,   789,    92,   791,   759,   759,
      67,   791,   443,   789,   790,   791,   480,   481,   482,   404,
     759,   789,   407,   791,    10,   410,   411,   412,   413,    92,
     415,   789,   417,   791,    92,   420,    93,   501,   423,   424,
     425,   505,   427,    10,    52,    53,    93,   294,   479,    35,
     297,    92,    38,   197,   789,   790,   791,   317,    92,   319,
     491,   446,    92,    10,    94,   436,   451,   531,    35,   454,
     317,    38,   457,    59,   505,   460,   461,    92,   468,   464,
     327,    92,    92,    94,   331,   789,    93,   791,    35,   474,
      92,    38,    94,   483,   484,   441,    92,   443,    94,    66,
       7,   896,   897,    10,   436,   490,   786,    93,   788,   480,
     481,   482,   497,    92,    61,    94,   342,   343,   344,    10,
     346,   347,    13,    14,   514,    32,    93,    92,    35,    94,
     501,    93,   503,   479,    92,    92,    94,    94,    92,   524,
      94,   789,   790,   529,    35,   491,    93,   479,    92,    92,
     482,   541,    93,    93,   539,   193,   540,   503,    93,   505,
     531,   507,    92,   548,    94,   511,    92,    82,   196,   197,
      93,    93,   557,   563,    95,    96,    97,    98,    99,   100,
     101,   441,    92,   443,    94,   570,    92,   331,    94,   436,
      34,    12,   578,   579,    46,    71,   627,   628,   629,   531,
     585,    39,    93,    92,    11,    94,    70,    93,   639,   640,
       6,   596,   131,     9,    10,   167,   169,   190,   143,   479,
     213,   606,   770,   447,   816,   772,   912,   148,    24,    25,
      26,   491,   479,    29,   619,   482,   912,   826,   779,    35,
     317,   626,   327,   503,   319,   505,   531,   507,   331,   634,
     503,   511,   759,   482,   505,   641,   294,   443,   505,   297,
     754,   633,   648,    -1,    -1,   651,    76,    77,    78,    79,
      80,    81,    68,    83,    -1,    -1,    -1,    -1,    -1,   317,
     665,   627,   628,   629,   531,    -1,    -1,   633,    -1,   515,
      -1,   676,   436,   639,   640,   759,   628,   629,    -1,   327,
      -1,    -1,   687,   331,     5,    -1,    -1,     8,   693,    -1,
      -1,    -1,    -1,    -1,   699,    16,    -1,   701,    -1,    20,
      21,   706,    23,   467,    -1,    -1,    11,    12,   759,    -1,
      -1,    -1,    -1,    -1,   719,    -1,   480,   481,   482,    40,
     726,    -1,    43,   728,    -1,    -1,   731,    48,    -1,    34,
     735,   736,    -1,   738,    39,    -1,   741,   501,    -1,   744,
      -1,    46,    47,    -1,    -1,   750,    -1,   627,   628,   629,
     760,   761,   762,   633,   764,    -1,    61,    -1,    -1,   639,
     640,   766,   629,    -1,   769,    70,    -1,   531,   773,    -1,
     775,   776,    93,   778,    -1,   780,    -1,    -1,   436,    -1,
      -1,    -1,   787,    -1,    -1,    -1,    -1,    -1,   436,    -1,
      -1,    -1,    -1,   759,    -1,   443,   801,    -1,   789,   790,
     806,    -1,    -1,    -1,   810,    -1,    -1,   813,   818,   819,
      -1,    -1,   817,    -1,   660,    -1,    -1,    -1,   823,   467,
      -1,   479,    -1,   828,   482,   830,    -1,    -1,     8,   834,
      10,    -1,   480,   481,   482,    -1,    -1,    -1,    -1,   844,
      20,    21,    -1,    23,    -1,   850,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,   859,    35,    -1,   505,    38,    -1,
     911,    -1,   913,    43,    -1,    45,    -1,    -1,    48,   874,
     875,   876,   877,   531,   880,   881,    -1,    -1,    -1,   759,
      -1,    -1,   887,   531,    -1,   890,    66,    -1,   893,     3,
      -1,     5,    -1,    10,     8,    -1,    -1,   902,   903,    16,
      -1,    15,    16,    -1,   914,    -1,    20,    21,    -1,    23,
      -1,    -1,    -1,    93,   919,    -1,    -1,   927,    35,   924,
      -1,    38,    -1,    40,    -1,    -1,    40,   932,   934,    43,
      -1,   937,    -1,    -1,    48,    -1,    -1,    -1,    55,    56,
      -1,    -1,    -1,    57,    58,   911,   912,   913,    62,    66,
      64,    65,    -1,    -1,    -1,     3,    -1,     5,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    -1,
     628,   629,    20,    21,    -1,    23,    93,    -1,    -1,    93,
     628,   629,    -1,    -1,    -1,    -1,     5,    -1,    -1,     8,
      -1,   639,    40,    -1,    -1,    43,    -1,    16,    -1,    -1,
      48,    20,    21,    -1,    23,    -1,    -1,    -1,    -1,    57,
      58,    -1,    -1,    -1,    62,    -1,    64,    65,    -1,    -1,
      -1,    40,    -1,    -1,    43,    -1,    -1,    -1,    -1,    48,
      -1,   911,   912,   913,    -1,     5,     6,    -1,     8,    -1,
      10,    -1,    -1,    -1,    -1,    93,    16,    -1,    -1,    19,
      20,    21,    -1,    23,    -1,    25,    26,    -1,    -1,    29,
      -1,    31,    -1,    -1,     5,    35,    -1,     8,    38,    10,
      40,    41,    -1,    43,    93,    45,    -1,    -1,    48,    20,
      21,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    66,    38,    -1,    -1,
      -1,    -1,    43,     5,    45,    -1,     8,    48,    10,    -1,
      -1,   759,    -1,    54,    16,    -1,    -1,    -1,    20,    21,
      -1,    23,    -1,    93,     5,    66,    -1,     8,    -1,    10,
      -1,    -1,    -1,    35,    -1,    16,    38,    -1,    40,    20,
      21,    43,    23,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    35,    -1,    -1,    38,    -1,    40,
      -1,    -1,    43,    -1,    66,    -1,     6,    48,     8,     9,
      10,    -1,    -1,    -1,     6,    -1,    -1,    -1,    10,    -1,
      20,    21,    -1,    23,    24,    -1,     6,    -1,    -1,     9,
      10,    93,    -1,    25,    26,    35,    -1,    29,    38,    31,
      -1,    -1,    -1,    35,    24,    45,    38,    39,    48,    29,
      42,    -1,    93,    45,    54,    35,    -1,     5,    38,    39,
       8,    -1,    42,    -1,    -1,    45,    66,    -1,    16,    -1,
      -1,    -1,    20,    21,    66,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    40,    93,    -1,    43,    -1,    -1,    -1,    -1,
      48,    93,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    93,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,     5,    -1,    -1,     8,
      -1,    10,    82,    -1,    -1,    -1,    -1,    16,    -1,    -1,
      19,    20,    21,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,    38,
       3,    40,     5,     6,    43,     8,    -1,    10,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    -1,
      23,    -1,    25,    26,    -1,    -1,    29,    66,    31,    -1,
      69,    -1,    35,    -1,    -1,    38,     5,     6,    -1,     8,
      43,    10,    45,    -1,    -1,    48,    -1,    16,    -1,    -1,
      -1,    20,    21,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    -1,    66,    -1,    -1,    35,    -1,    -1,    38,
       3,    40,     5,     6,    43,     8,    45,    10,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    -1,
      23,    24,    -1,    -1,    -1,    -1,    29,    66,    -1,    68,
      -1,    -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,
      43,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    27,    28,    96,    97,    99,     3,     4,     5,     6,
       7,     8,     9,    10,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    82,   329,
     329,     0,    98,   100,    92,    92,    76,    77,    78,    79,
      80,    81,    83,   191,   192,   193,   198,   199,   204,   208,
     212,   213,   191,   329,    76,    77,    78,    79,    80,    81,
      83,    84,   328,   329,    52,    53,   329,   329,   328,    85,
      86,    87,    88,   214,   328,   331,    30,    33,    60,   101,
     102,   103,   121,   122,   124,   192,   192,   192,   192,   192,
     192,   192,     4,   106,   107,   122,   194,   200,    92,    94,
     190,   190,   205,   209,   190,   190,   215,   331,   327,   329,
      86,   109,   102,   191,   191,   191,   329,   109,   191,   191,
      92,    94,   195,    92,    94,   201,   192,    92,    92,   190,
     190,   190,   190,    17,    18,   104,   110,   130,   133,   108,
     104,   122,   107,   191,   191,    93,   191,   191,   329,   329,
       7,    10,    32,    35,   105,   111,   116,   117,   118,   119,
     191,   191,    92,   111,   191,   191,     5,     8,    16,    19,
      20,    21,    23,    29,    31,    38,    40,    43,    48,    66,
      69,   114,   118,   119,   120,   141,   147,   196,   197,   216,
     221,   228,   232,   236,   242,   243,   245,   256,   260,   264,
     311,   118,   119,   120,   202,   203,     3,     6,    24,    45,
     114,   115,   118,   119,   120,   141,   206,   207,   221,   226,
     227,   270,   274,    25,    26,   114,   115,   141,   210,   211,
     221,   240,   241,   242,   270,   274,   131,   134,   331,   331,
     331,   331,   191,    37,   112,   125,   191,   112,   329,   329,
     329,   331,   329,   329,   329,   331,   331,    49,    50,    51,
     123,   329,   328,   329,   328,   331,    93,   191,    93,   191,
     331,    52,    53,    52,    53,   331,    93,   191,   331,   331,
      93,   191,    92,    92,    94,   135,   190,   190,   190,   190,
      85,   129,    15,    57,    58,    62,    64,    65,    93,   113,
     114,   136,   142,   147,   256,   270,   275,   286,   291,   316,
     191,   124,    93,   246,   217,   257,   190,   229,   233,   237,
      94,   222,   190,   190,   148,    94,   261,   312,   190,   265,
     196,   202,   271,   190,   190,   190,   190,   190,   206,   190,
     190,   210,   191,   191,    94,   126,   329,   329,   329,   331,
     329,   329,   191,   191,    92,    94,   247,    92,    94,   218,
      92,    92,    92,    92,    92,    92,    92,    92,    94,   313,
      92,    94,   266,    92,   124,   125,   132,    92,   317,   276,
     287,   292,   137,   143,    93,   191,   191,   191,   191,   191,
     191,   223,   191,   262,   191,   191,   191,   191,   191,    93,
     191,    92,    94,   318,    92,    94,   277,    92,    94,   288,
      92,    92,    94,   138,    92,    94,   144,   248,    68,   114,
     115,   141,   147,   219,   220,   221,   225,   256,   274,   258,
     230,   234,   238,    13,    14,    93,   118,   119,   175,   176,
     224,   149,    93,   118,   119,   120,   141,   263,   264,   270,
     274,   314,   267,   268,   191,   272,   132,   127,   191,   191,
     191,   191,   191,   191,     9,    54,    93,   115,   141,   216,
     227,   228,   232,   236,   249,   250,   274,   311,   326,   331,
      93,   191,    93,   114,   118,   119,   120,   147,   256,   259,
      39,    42,    93,   115,   141,   151,   221,   227,   231,   274,
     325,   326,    93,   115,   141,   151,   221,   235,   240,   241,
     242,   274,   325,    41,    93,   114,   115,   141,   147,   221,
     239,   240,   241,   242,   243,   244,   256,   274,   331,   331,
     191,    93,   118,   119,   120,   150,   151,   325,   326,   191,
      93,   115,   141,   221,   227,   274,   315,    93,   118,   119,
     221,   225,   226,   227,   240,   241,   269,   326,    93,   114,
     118,   119,   120,   141,   216,   228,   232,   236,   250,   273,
     274,   311,    93,    93,   118,   119,   128,   319,   278,   289,
      63,   118,   119,   293,   294,   295,   296,   301,   306,   139,
     145,   331,   329,   191,   190,   219,   191,   328,   331,   191,
     191,   331,   191,   190,   190,   191,   191,   191,   191,   191,
      59,    93,   118,   119,   120,   320,   321,    55,    56,    93,
     118,   119,   120,   141,   147,   256,   279,   280,   284,    93,
     114,   118,   119,   120,   141,   147,   256,   290,    72,    73,
      74,    75,    93,   294,   191,    93,   118,   119,   120,   140,
     141,    61,    93,   118,   119,   120,   146,   181,   190,   251,
     152,   190,   190,   329,   191,   281,   285,   191,   191,    92,
      94,   297,   302,   307,   191,   191,   328,   191,    92,    94,
     252,    92,    94,   153,   322,    92,    92,   191,    92,    94,
     298,    92,    94,   303,    92,    94,   308,   190,   191,   191,
      92,    94,   323,   191,   191,    93,   191,   191,   191,   253,
      11,    12,    34,    46,    47,    70,   151,   154,   155,   156,
     158,   159,   165,   166,   177,   178,   179,   180,   181,   182,
     183,   189,   191,   114,   147,   256,   282,   283,   282,   299,
     304,   309,    93,   118,   119,   120,   141,   216,   228,   232,
     236,   254,   255,   260,   274,   311,   331,   331,   331,    82,
     331,    52,    53,   330,   191,    93,   191,   156,    22,    36,
     160,   161,   163,   166,   191,   191,   191,   191,   183,   191,
     151,    71,   324,    93,   283,   191,    93,    93,   221,   226,
     227,   240,   241,   244,   300,   325,   326,    93,   221,   244,
     305,   325,   326,    93,   151,   226,   227,   240,   241,   310,
     325,   326,   191,   190,   167,   157,   184,   190,   190,   158,
     191,   331,   331,   191,   179,   178,   181,   179,   191,   191,
      52,    53,    93,   191,   191,   191,   191,    92,    94,   168,
      92,    94,   172,    92,    94,   185,   162,   164,   191,   191,
     191,   191,   190,   190,   191,   191,   191,   172,   172,   191,
     191,   169,   173,   186,    44,    93,   118,   119,   120,   170,
     171,    93,   118,   119,   174,   175,   176,    67,    93,   118,
     119,   120,   187,   188,   331,   191,   191,   331,   191,   190,
     190
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,    95,    96,    96,    98,    97,   100,    99,   101,   102,
     102,   103,   103,   103,   104,   104,   105,   105,   105,   105,
     106,   106,   106,   108,   107,   109,   109,   110,   110,   111,
     111,   112,   112,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   114,   114,   114,   114,   114,   114,   114,
     115,   115,   115,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   123,   123,   124,   125,   126,   125,   127,   127,
     128,   128,   129,   131,   130,   132,   132,   134,   133,   135,
     135,   137,   136,   138,   138,   139,   139,   140,   140,   140,
     140,   141,   143,   142,   144,   144,   145,   145,   146,   146,
     146,   146,   148,   147,   149,   149,   150,   150,   150,   150,
     150,   150,   152,   151,   153,   153,   154,   154,   154,   154,
     154,   154,   154,   155,   155,   155,   155,   157,   156,   158,
     159,   159,   160,   160,   162,   161,   164,   163,   165,   165,
     167,   166,   168,   168,   169,   169,   170,   170,   170,   170,
     171,   172,   172,   173,   173,   174,   174,   174,   174,   175,
     176,   177,   177,   177,   178,   179,   180,   180,   180,   181,
     182,   182,   184,   183,   185,   185,   186,   186,   187,   187,
     187,   187,   188,   189,   189,   190,   190,   191,   191,   192,
     192,   192,   192,   192,   192,   192,   192,   194,   193,   195,
     195,   196,   196,   197,   197,   197,   197,   197,   197,   197,
     197,   197,   197,   197,   198,   198,   200,   199,   201,   201,
     202,   202,   203,   203,   203,   205,   204,   206,   206,   207,
     207,   207,   207,   207,   207,   207,   209,   208,   210,   210,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   212,
     214,   213,   215,   213,   217,   216,   218,   218,   219,   219,
     220,   220,   220,   220,   220,   220,   220,   220,   222,   221,
     221,   223,   223,   224,   224,   224,   224,   225,   226,   226,
     227,   227,   229,   228,   230,   230,   231,   231,   231,   231,
     231,   231,   231,   231,   233,   232,   234,   234,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   237,   236,   238,
     238,   239,   239,   239,   239,   239,   239,   239,   239,   239,
     239,   239,   239,   240,   241,   242,   243,   244,   246,   245,
     247,   247,   248,   248,   249,   249,   249,   249,   249,   249,
     251,   250,   250,   250,   250,   250,   250,   252,   252,   253,
     253,   254,   254,   254,   254,   254,   254,   255,   255,   255,
     255,   255,   255,   257,   256,   258,   258,   259,   259,   259,
     259,   259,   259,   261,   260,   260,   262,   262,   263,   263,
     263,   263,   263,   263,   263,   265,   264,   266,   266,   267,
     268,   268,   269,   269,   269,   269,   269,   269,   269,   269,
     269,   271,   270,   272,   272,   273,   273,   273,   273,   273,
     273,   273,   274,   276,   275,   277,   277,   278,   278,   279,
     279,   279,   279,   279,   279,   279,   279,   281,   280,   282,
     282,   283,   283,   283,   285,   284,   287,   286,   288,   288,
     289,   289,   290,   290,   290,   290,   290,   290,   290,   292,
     291,   293,   293,   294,   294,   294,   294,   294,   294,   295,
     295,   297,   296,   298,   298,   299,   299,   300,   300,   300,
     300,   300,   300,   300,   300,   302,   301,   303,   303,   304,
     304,   305,   305,   305,   305,   307,   306,   308,   308,   309,
     309,   310,   310,   310,   310,   310,   310,   310,   312,   311,
     313,   313,   314,   314,   315,   315,   315,   315,   315,   317,
     316,   318,   318,   319,   319,   320,   320,   320,   320,   322,
     321,   323,   323,   324,   324,   324,   325,   326,   327,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     329,   330,   330,   331,   331,   331,   331,   331
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     0,    11,     0,    11,     1,     0,
       2,     2,     2,     2,     0,     3,     1,     1,     1,     1,
       4,     4,     2,     0,     8,     0,     2,     2,     2,     0,
       3,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     3,     3,     0,     7,     0,     3,
       1,     1,     1,     0,     9,     0,     2,     0,     4,     1,
       4,     0,     4,     1,     4,     0,     3,     1,     1,     1,
       1,     3,     0,     4,     1,     4,     0,     3,     1,     1,
       1,     1,     0,     7,     0,     3,     1,     1,     1,     1,
       1,     1,     0,     4,     1,     4,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     2,     0,     4,     3,
       0,     2,     1,     1,     0,     4,     0,     4,     2,     3,
       0,     4,     1,     4,     0,     3,     1,     1,     1,     1,
       3,     1,     4,     0,     3,     1,     1,     1,     1,     3,
       3,     2,     4,     4,     3,     3,     2,     4,     4,     3,
       2,     3,     0,     4,     1,     4,     0,     3,     1,     1,
       1,     1,     3,     2,     3,     1,     3,     0,     1,     0,
       2,     2,     2,     2,     2,     2,     2,     0,     4,     1,
       4,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     0,     4,     1,     4,
       0,     3,     1,     1,     1,     0,     7,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     0,     7,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       0,     3,     0,     4,     0,     4,     1,     4,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     6,
       3,     0,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     0,     7,     0,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     7,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     7,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     0,     4,
       1,     4,     0,     3,     1,     1,     1,     1,     1,     1,
       0,     4,     1,     1,     1,     1,     1,     1,     4,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     7,     0,     3,     1,     1,     1,
       1,     1,     1,     0,     6,     3,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     1,     4,     1,
       0,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     7,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     0,     4,     1,     4,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     6,     2,
       3,     1,     1,     1,     0,     6,     0,     4,     1,     4,
       0,     3,     1,     1,     1,     1,     1,     1,     1,     0,
       7,     2,     3,     1,     1,     1,     1,     1,     1,     3,
       5,     0,     4,     1,     4,     0,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     1,     4,     0,
       3,     1,     1,     1,     1,     0,     4,     1,     4,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     4,
       1,     4,     0,     3,     1,     1,     1,     1,     1,     0,
       4,     4,     1,     0,     3,     1,     1,     1,     1,     0,
       4,     4,     1,     0,     4,     4,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parserPtr, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parserPtr); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (parserPtr);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parserPtr);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, struct Parser *parserPtr)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parserPtr);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parserPtr); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, struct Parser *parserPtr)
{
  YY_USE (yyvaluep);
  YY_USE (parserPtr);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct Parser *parserPtr)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, parserPtr);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* $@1: %empty  */
#line 584 "parser-yang.y"
                {
                    currentParser = thisParserPtr;
                    thisParserPtr->yangModulePtr = findYangModuleByName((yyvsp[0].text), NULL);
                    if (!thisParserPtr->yangModulePtr) {
                        thisParserPtr->yangModulePtr =  addYangNode((yyvsp[0].text), YANG_DECL_MODULE, NULL);
                    
                        if (smiHandle->firstYangModulePtr) {
                            smiHandle->firstYangModulePtr->nextSiblingPtr = thisModulePtr;
                        } else {
                            smiHandle->firstYangModulePtr = thisModulePtr;
                        }
                    } else {
                        smiPrintError(thisParserPtr, ERR_MODULE_ALREADY_LOADED, (yyvsp[0].text));
                        free((yyvsp[0].text));
                        /*
                         * this aborts parsing the whole file,
                         * not only the current module.
                         */
                        YYABORT;
                    }
                    thisModulePtr->info = createModuleInfo(thisModulePtr);
                    pushNode(thisModulePtr);
                }
#line 2592 "parser-yang.c"
    break;

  case 5: /* moduleStatement: moduleKeyword identifierStr $@1 '{' stmtSep moduleHeaderStatement_0n linkageStatement_0n moduleMetaStatement_0n revisionStatement_0n bodyStatement_0n '}'  */
#line 615 "parser-yang.y"
                {
                    thisModuleInfoPtr->parsingState  = YANG_PARSING_DONE;
                    pop();
                    yangSemanticAnalysis(thisModulePtr);
                }
#line 2602 "parser-yang.c"
    break;

  case 6: /* $@2: %empty  */
#line 623 "parser-yang.y"
                    {
                        currentParser = thisParserPtr;
                        thisParserPtr->yangModulePtr = findYangModuleByName((yyvsp[0].text), NULL);
                        if (!thisParserPtr->yangModulePtr) {
                            thisParserPtr->yangModulePtr =  addYangNode((yyvsp[0].text), YANG_DECL_SUBMODULE, NULL);
                    
                            if (smiHandle->firstYangModulePtr) {
                                smiHandle->firstYangModulePtr->nextSiblingPtr = thisModulePtr;
                            } else {
                                smiHandle->firstYangModulePtr = thisModulePtr;
                            }
                        } else {
                            smiPrintError(thisParserPtr, ERR_MODULE_ALREADY_LOADED, (yyvsp[0].text));
                            free((yyvsp[0].text));
                            /*
                             * this aborts parsing the whole file,
                             * not only the current module.
                             */
                            YYABORT;
                        }
                        currentParser = thisParserPtr;
                        thisModulePtr->info = createModuleInfo(thisModulePtr);
                        pushNode(thisModulePtr);
                    }
#line 2631 "parser-yang.c"
    break;

  case 7: /* submoduleStatement: submoduleKeyword identifierStr $@2 '{' stmtSep submoduleHeaderStatement linkageStatement_0n moduleMetaStatement_0n revisionStatement_0n bodyStatement_0n '}'  */
#line 655 "parser-yang.y"
                    {
                        thisModuleInfoPtr->parsingState  = YANG_PARSING_DONE;
                        pop();
                        yangSemanticAnalysis(thisModulePtr);
                    }
#line 2641 "parser-yang.c"
    break;

  case 8: /* moduleHeaderStatement_0n: moduleHeaderStatement0_n  */
#line 663 "parser-yang.y"
                        {
                            if (!thisModuleInfoPtr->namespace) {
                                smiPrintError(parserPtr, ERR_NAMESPACE_MISSING, NULL);
                            }
                            if (!thisModuleInfoPtr->prefix) {
                                smiPrintError(parserPtr, ERR_PREFIX_MISSING, NULL);
                            }
			}
#line 2654 "parser-yang.c"
    break;

  case 14: /* moduleMetaStatement_0n: %empty  */
#line 685 "parser-yang.y"
                        {}
#line 2660 "parser-yang.c"
    break;

  case 23: /* $@3: %empty  */
#line 710 "parser-yang.y"
                    {
                        node = addYangNode((yyvsp[0].text), YANG_DECL_BELONGS_TO, topNode());
                        pushNode(node);
                    }
#line 2669 "parser-yang.c"
    break;

  case 24: /* belongsToStatement: belongs_toKeyword identifierStr $@3 '{' stmtSep prefixStatement stmtSep '}'  */
#line 717 "parser-yang.y"
                    {
                        pop();
                    }
#line 2677 "parser-yang.c"
    break;

  case 25: /* linkageStatement_0n: %empty  */
#line 722 "parser-yang.y"
                     {}
#line 2683 "parser-yang.c"
    break;

  case 29: /* revisionStatement_0n: %empty  */
#line 732 "parser-yang.y"
                      {}
#line 2689 "parser-yang.c"
    break;

  case 31: /* bodyStatement_0n: %empty  */
#line 737 "parser-yang.y"
                  {}
#line 2695 "parser-yang.c"
    break;

  case 54: /* organizationStatement: organizationKeyword string stmtEnd  */
#line 788 "parser-yang.y"
                        {
                            if (!thisModuleInfoPtr->organization) {
                                node = addYangNode((yyvsp[-1].text), YANG_DECL_ORGANIZATION, topNode());
                                thisModuleInfoPtr->organization = node->export.value;
                            } else {
                                smiPrintError(currentParser, ERR_REDEFINED_ORGANIZATION, NULL);
                            }
			}
#line 2708 "parser-yang.c"
    break;

  case 55: /* contactStatement: contactKeyword string stmtEnd  */
#line 799 "parser-yang.y"
                        {
                            if (!thisModuleInfoPtr->contact) {
                                node = addYangNode((yyvsp[-1].text), YANG_DECL_CONTACT, topNode());
                                thisModuleInfoPtr->contact = node->export.value;
                            } else {
                                smiPrintError(currentParser, ERR_REDEFINED_CONTACT, NULL);
                            }
			}
#line 2721 "parser-yang.c"
    break;

  case 56: /* descriptionStatement: descriptionKeyword string stmtEnd  */
#line 810 "parser-yang.y"
                        {
                            uniqueNodeKind(topNode(), YANG_DECL_DESCRIPTION);
                            setDescription(topNode(), (yyvsp[-1].text));
                            node = addYangNode((yyvsp[-1].text), YANG_DECL_DESCRIPTION, topNode());
			}
#line 2731 "parser-yang.c"
    break;

  case 57: /* referenceStatement: referenceKeyword string stmtEnd  */
#line 818 "parser-yang.y"
                        {
                            uniqueNodeKind(topNode(), YANG_DECL_REFERENCE);
                            setReference(topNode(), (yyvsp[-1].text));
                            node = addYangNode((yyvsp[-1].text), YANG_DECL_REFERENCE, topNode());
			}
#line 2741 "parser-yang.c"
    break;

  case 58: /* statusStatement: statusKeyword status stmtEnd  */
#line 826 "parser-yang.y"
                        {
                            uniqueNodeKind(topNode(), YANG_DECL_STATUS);
                            setStatus(topNode(), (yyvsp[-1].rc));
                            node = addYangNode(yangStatusAsString((yyvsp[-1].rc)), YANG_DECL_STATUS, topNode());
			}
#line 2751 "parser-yang.c"
    break;

  case 59: /* namespaceStatement: namespaceKeyword string stmtEnd  */
#line 834 "parser-yang.y"
                        {
                            if (!thisModuleInfoPtr->namespace) {
                                node = addYangNode((yyvsp[-1].text), YANG_DECL_NAMESPACE, topNode());
                                thisModuleInfoPtr->namespace = node->export.value;
                            } else {
                                smiPrintError(currentParser, ERR_REDEFINED_NAMESPACE, NULL);
                            }
			}
#line 2764 "parser-yang.c"
    break;

  case 60: /* yangVersionStatement: yangversionKeyword yangVersion stmtEnd  */
#line 845 "parser-yang.y"
                        {
                            if (!thisModuleInfoPtr->version) {
                                node = addYangNode((yyvsp[-1].text), YANG_DECL_YANG_VERSION, topNode());
                                thisModuleInfoPtr->version = node->export.value;
                            } else {
                                smiPrintError(currentParser, ERR_REDEFINED_YANGVERSION, NULL);
                            }
			}
#line 2777 "parser-yang.c"
    break;

  case 61: /* status: deprecatedKeyword  */
#line 856 "parser-yang.y"
                {
                    (yyval.rc) = YANG_STATUS_DEPRECATED;
		}
#line 2785 "parser-yang.c"
    break;

  case 62: /* status: currentKeyword  */
#line 861 "parser-yang.y"
                {
                    (yyval.rc) = YANG_STATUS_CURRENT;
		}
#line 2793 "parser-yang.c"
    break;

  case 63: /* status: obsoleteKeyword  */
#line 866 "parser-yang.y"
                {
                    (yyval.rc) = YANG_STATUS_OBSOLETE;
		}
#line 2801 "parser-yang.c"
    break;

  case 64: /* prefixStatement: prefixKeyword prefix stmtEnd  */
#line 872 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[-1].text), YANG_DECL_PREFIX, topNode());
                            switch(topDecl())
                            {
                                case YANG_DECL_MODULE:
                                    if(!thisModuleInfoPtr->prefix)
                                        thisModuleInfoPtr->prefix = node->export.value;
                                    else
                                        smiPrintError(currentParser, ERR_REDEFINED_PREFIX, NULL);
                                    break;
                                case YANG_DECL_BELONGS_TO:
                                    thisModuleInfoPtr->prefix = node->export.value;
                                case YANG_DECL_IMPORT:

                                    break;
                                default:
                                    /* TODO print error */
                                    debug("DEBUGG: OOPS wrong prefix DECL %d, at line %d\n", topDecl(), currentParser->line);
                                    break;
                            }
			}
#line 2827 "parser-yang.c"
    break;

  case 65: /* revisionStatement: revisionKeyword date ';'  */
#line 896 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[-1].text), YANG_DECL_REVISION, topNode());
                        }
#line 2835 "parser-yang.c"
    break;

  case 66: /* $@4: %empty  */
#line 901 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[0].text), YANG_DECL_REVISION, topNode());
                            pushNode(node);
			}
#line 2844 "parser-yang.c"
    break;

  case 67: /* revisionStatement: revisionKeyword date $@4 '{' stmtSep revisionSubstatement_On '}'  */
#line 909 "parser-yang.y"
                        {
                            pop();
			}
#line 2852 "parser-yang.c"
    break;

  case 68: /* revisionSubstatement_On: %empty  */
#line 914 "parser-yang.y"
                         {}
#line 2858 "parser-yang.c"
    break;

  case 72: /* date: dateString  */
#line 925 "parser-yang.y"
        {
            checkDate(currentParser, (yyvsp[0].text));
	}
#line 2866 "parser-yang.c"
    break;

  case 73: /* $@5: %empty  */
#line 931 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_IMPORT, topNode());
                    pushNode(node);
		}
#line 2875 "parser-yang.c"
    break;

  case 74: /* importStatement: importKeyword identifierStr $@5 '{' stmtSep prefixStatement stmtSep optionalRevision '}'  */
#line 940 "parser-yang.y"
                {
		    _YangNode* importNode;
                    externalModule(topNode());
                    importNode = topNode();
                    pop();
                    if (topNode() != thisModulePtr) {
                        importNode = topNode();
                        pop();
                    }
                    if (!findChildNodeByType(importNode, YANG_DECL_REVISION)) {
                        smiPrintError(currentParser, ERR_IMPORT_REQUIRES_REVISION);
                    }
		}
#line 2893 "parser-yang.c"
    break;

  case 75: /* optionalRevision: %empty  */
#line 955 "parser-yang.y"
                  {}
#line 2899 "parser-yang.c"
    break;

  case 77: /* $@6: %empty  */
#line 961 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_INCLUDE, topNode());
                    pushNode(node);
		}
#line 2908 "parser-yang.c"
    break;

  case 78: /* includeStatement: includeKeyword identifierStr $@6 includeStatementBody  */
#line 966 "parser-yang.y"
                {
                    _YangNode *includedModule = externalModule(topNode());
                    yangValidateInclude(thisModulePtr, includedModule);
                    pop();
                    if (topNode() != thisModulePtr) {
                        pop();
                    }
		}
#line 2921 "parser-yang.c"
    break;

  case 79: /* includeStatementBody: ';'  */
#line 976 "parser-yang.y"
                                  {}
#line 2927 "parser-yang.c"
    break;

  case 80: /* includeStatementBody: '{' stmtSep optionalRevision '}'  */
#line 981 "parser-yang.y"
                        {}
#line 2933 "parser-yang.c"
    break;

  case 81: /* $@7: %empty  */
#line 985 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_FEATURE, topNode());
                    pushNode(node);
                }
#line 2942 "parser-yang.c"
    break;

  case 82: /* featureStatement: featureKeyword identifierStr $@7 featureSpec  */
#line 990 "parser-yang.y"
                {
                    pop();
                }
#line 2950 "parser-yang.c"
    break;

  case 83: /* featureSpec: ';'  */
#line 996 "parser-yang.y"
                    {}
#line 2956 "parser-yang.c"
    break;

  case 84: /* featureSpec: '{' stmtSep featureSubstatement_0n '}'  */
#line 1001 "parser-yang.y"
                    {}
#line 2962 "parser-yang.c"
    break;

  case 85: /* featureSubstatement_0n: %empty  */
#line 1004 "parser-yang.y"
                        {}
#line 2968 "parser-yang.c"
    break;

  case 91: /* ifFeatureStatement: ifFeatureKeyword identifierRef stmtEnd  */
#line 1018 "parser-yang.y"
                    {
                        node = addYangNode((yyvsp[-1].text), YANG_DECL_IF_FEATURE, topNode());
                        createIdentifierRef(node, getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)));
                    }
#line 2977 "parser-yang.c"
    break;

  case 92: /* $@8: %empty  */
#line 1025 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_IDENTITY, topNode());
                    pushNode(node);
                }
#line 2986 "parser-yang.c"
    break;

  case 93: /* identityStatement: identityKeyword identifierStr $@8 identitySpec  */
#line 1030 "parser-yang.y"
                {
                    pop();
                }
#line 2994 "parser-yang.c"
    break;

  case 94: /* identitySpec: ';'  */
#line 1034 "parser-yang.y"
                     {}
#line 3000 "parser-yang.c"
    break;

  case 95: /* identitySpec: '{' stmtSep identitySubstatement_0n '}'  */
#line 1039 "parser-yang.y"
                    {}
#line 3006 "parser-yang.c"
    break;

  case 96: /* identitySubstatement_0n: %empty  */
#line 1042 "parser-yang.y"
                         {}
#line 3012 "parser-yang.c"
    break;

  case 102: /* $@9: %empty  */
#line 1056 "parser-yang.y"
                {
                    if (getBuiltInType((yyvsp[0].text)) != YANG_TYPE_NONE) {
                        smiPrintError(thisParserPtr, ERR_ILLEGAL_TYPE_NAME, (yyvsp[0].text));
                    }
                    node = addYangNode((yyvsp[0].text), YANG_DECL_TYPEDEF, topNode());
                    pushNode(node);
                }
#line 3024 "parser-yang.c"
    break;

  case 103: /* typedefStatement: typedefKeyword identifierStr $@9 '{' stmtSep typedefSubstatement_0n '}'  */
#line 1067 "parser-yang.y"
                {                                
                    if (getCardinality(topNode(), YANG_DECL_TYPE) != 1) {
                        smiPrintError(currentParser, ERR_WRONG_CARDINALITY, yangDeclAsString(YANG_DECL_TYPE), "1");
                    }
                    pop();
                }
#line 3035 "parser-yang.c"
    break;

  case 104: /* typedefSubstatement_0n: %empty  */
#line 1075 "parser-yang.y"
                        {}
#line 3041 "parser-yang.c"
    break;

  case 112: /* $@10: %empty  */
#line 1095 "parser-yang.y"
               {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_TYPE, topNode());
                    createTypeInfo(node);
                    if (getBuiltInType((yyvsp[0].text)) == YANG_TYPE_NONE) {
                        createIdentifierRef(node, getPrefix((yyvsp[0].text)), getIdentifier((yyvsp[0].text)));
                    }
                    pushNode(node);
               }
#line 3054 "parser-yang.c"
    break;

  case 113: /* typeStatement: typeKeyword identifierRef $@10 optionalTypeBodyStatements  */
#line 1104 "parser-yang.y"
               {
                    pop();
               }
#line 3062 "parser-yang.c"
    break;

  case 114: /* optionalTypeBodyStatements: ';'  */
#line 1109 "parser-yang.y"
                                {}
#line 3068 "parser-yang.c"
    break;

  case 115: /* optionalTypeBodyStatements: '{' stmtSep typeBodyStmts '}'  */
#line 1114 "parser-yang.y"
                                {}
#line 3074 "parser-yang.c"
    break;

  case 127: /* $@11: %empty  */
#line 1145 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_RANGE);
                    node = addYangNode((yyvsp[0].text), YANG_DECL_RANGE, topNode());
                    pushNode(node);
		}
#line 3084 "parser-yang.c"
    break;

  case 128: /* range: rangeKeyword string $@11 optionalRestrictionSpec  */
#line 1151 "parser-yang.y"
                {
			pop();
		}
#line 3092 "parser-yang.c"
    break;

  case 129: /* fractionDigitsStatement: fractionDigitsKeyword string stmtEnd  */
#line 1157 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_FRACTION_DIGITS);
                    node = addYangNode((yyvsp[-1].text), YANG_DECL_FRACTION_DIGITS, topNode());
		}
#line 3101 "parser-yang.c"
    break;

  case 130: /* stringRestriction_0n: %empty  */
#line 1163 "parser-yang.y"
                      {}
#line 3107 "parser-yang.c"
    break;

  case 134: /* $@12: %empty  */
#line 1174 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_LENGTH);
                    node = addYangNode((yyvsp[0].text), YANG_DECL_LENGTH, topNode());
                    pushNode(node);
                }
#line 3117 "parser-yang.c"
    break;

  case 135: /* length: lengthKeyword string $@12 optionalRestrictionSpec  */
#line 1180 "parser-yang.y"
                {
			pop();
		}
#line 3125 "parser-yang.c"
    break;

  case 136: /* $@13: %empty  */
#line 1187 "parser-yang.y"
        {
            node = addYangNode((yyvsp[0].text), YANG_DECL_PATTERN, topNode());
            pushNode(node);
        }
#line 3134 "parser-yang.c"
    break;

  case 137: /* pattern: patternKeyword string $@13 optionalRestrictionSpec  */
#line 1192 "parser-yang.y"
        {
            pop();
        }
#line 3142 "parser-yang.c"
    break;

  case 140: /* $@14: %empty  */
#line 1203 "parser-yang.y"
        {
            if (strlen((yyvsp[0].text)) == 0 || isWSP((yyvsp[0].text)[0]) || isWSP((yyvsp[0].text)[strlen((yyvsp[0].text))-1])) {
                smiPrintError(currentParser, ERR_WRONG_ENUM);
            }
            node = findChildNodeByTypeAndValue(topNode(), YANG_DECL_ENUM, (yyvsp[0].text));
            if (node) {
                smiPrintError(currentParser, ERR_DUPLICATED_ENUM_NAME, (yyvsp[0].text));
            }
            node = addYangNode((yyvsp[0].text), YANG_DECL_ENUM, topNode());
            pushNode(node);
        }
#line 3158 "parser-yang.c"
    break;

  case 141: /* enum: enumKeyword string $@14 enumSubstatementSpec  */
#line 1215 "parser-yang.y"
        {
            pop();
        }
#line 3166 "parser-yang.c"
    break;

  case 142: /* enumSubstatementSpec: ';'  */
#line 1220 "parser-yang.y"
                          {}
#line 3172 "parser-yang.c"
    break;

  case 143: /* enumSubstatementSpec: '{' stmtSep enumSubstatement_0n '}'  */
#line 1225 "parser-yang.y"
              {}
#line 3178 "parser-yang.c"
    break;

  case 144: /* enumSubstatement_0n: %empty  */
#line 1228 "parser-yang.y"
                     {}
#line 3184 "parser-yang.c"
    break;

  case 150: /* valueStatement: valueKeyword string stmtEnd  */
#line 1243 "parser-yang.y"
            {                
                node = addYangNode((yyvsp[-1].text), YANG_DECL_VALUE, topNode());
            }
#line 3192 "parser-yang.c"
    break;

  case 151: /* optionalRestrictionSpec: ';'  */
#line 1248 "parser-yang.y"
                             {}
#line 3198 "parser-yang.c"
    break;

  case 152: /* optionalRestrictionSpec: '{' stmtSep restrictionSpec_0n '}'  */
#line 1253 "parser-yang.y"
                     {}
#line 3204 "parser-yang.c"
    break;

  case 153: /* restrictionSpec_0n: %empty  */
#line 1256 "parser-yang.y"
                    {}
#line 3210 "parser-yang.c"
    break;

  case 159: /* errorMessageStatement: error_messageKeyword string stmtEnd  */
#line 1271 "parser-yang.y"
            {
                uniqueNodeKind(topNode(), YANG_DECL_ERROR_MESSAGE);
                node = addYangNode((yyvsp[-1].text), YANG_DECL_ERROR_MESSAGE, topNode());
            }
#line 3219 "parser-yang.c"
    break;

  case 160: /* errorAppTagStatement: error_app_tagKeyword string stmtEnd  */
#line 1278 "parser-yang.y"
            {
                uniqueNodeKind(topNode(), YANG_DECL_ERROR_APP_TAG);
                node = addYangNode((yyvsp[-1].text), YANG_DECL_ERROR_APP_TAG, topNode());
            }
#line 3228 "parser-yang.c"
    break;

  case 164: /* path: pathKeyword string stmtEnd  */
#line 1294 "parser-yang.y"
                {
            uniqueNodeKind(topNode(), YANG_DECL_PATH);
            node = addYangNode((yyvsp[-1].text), YANG_DECL_PATH, topNode());
		}
#line 3237 "parser-yang.c"
    break;

  case 165: /* requireInstanceStatement: requireInstanceKeyword booleanValue stmtEnd  */
#line 1301 "parser-yang.y"
        {
            uniqueNodeKind(topNode(), YANG_DECL_REQUIRE_INSTANCE);
            if ((yyvsp[-1].rc) == YANG_BOOLEAN_TRUE) {
                node = addYangNode("true", YANG_DECL_REQUIRE_INSTANCE, topNode());
            } else {
                node = addYangNode("false", YANG_DECL_REQUIRE_INSTANCE, topNode());
            }
        }
#line 3250 "parser-yang.c"
    break;

  case 169: /* baseStatement: baseKeyword identifierRef stmtEnd  */
#line 1321 "parser-yang.y"
            {
                uniqueNodeKind(topNode(), YANG_DECL_BASE);
                node = addYangNode((yyvsp[-1].text), YANG_DECL_BASE, topNode());
                createIdentifierRef(node, getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)));
            }
#line 3260 "parser-yang.c"
    break;

  case 172: /* $@15: %empty  */
#line 1334 "parser-yang.y"
            {
                node = findChildNodeByTypeAndValue(topNode(), YANG_DECL_BIT, (yyvsp[0].text));
                if (node) {
                    smiPrintError(currentParser, ERR_DUPLICATED, "bit", (yyvsp[0].text));
                }

                node = addYangNode((yyvsp[0].text), YANG_DECL_BIT, topNode());
                pushNode(node);
            }
#line 3274 "parser-yang.c"
    break;

  case 173: /* bitsStatement: bitKeyword identifier $@15 bitsSubstatementSpec  */
#line 1344 "parser-yang.y"
            {
                pop();
            }
#line 3282 "parser-yang.c"
    break;

  case 174: /* bitsSubstatementSpec: ';'  */
#line 1349 "parser-yang.y"
                            {}
#line 3288 "parser-yang.c"
    break;

  case 175: /* bitsSubstatementSpec: '{' stmtSep bitsSubstatement_0n '}'  */
#line 1354 "parser-yang.y"
                   {}
#line 3294 "parser-yang.c"
    break;

  case 176: /* bitsSubstatement_0n: %empty  */
#line 1357 "parser-yang.y"
                     {}
#line 3300 "parser-yang.c"
    break;

  case 182: /* positionStatement: positionKeyword string stmtEnd  */
#line 1372 "parser-yang.y"
                {
		    _YangNode* typePtr, *childPtr;
                    if (!isNonNegativeInteger((yyvsp[-1].text))) {
                        smiPrintError(currentParser, ERR_ARG_VALUE, (yyvsp[-1].text), "non-negative-integer");
                    }                    
                    uniqueNodeKind(topNode(), YANG_DECL_POSITION);

                    /* position values must be unique within the type */
                    typePtr = topNode()->parentPtr;
                    childPtr = typePtr->firstChildPtr;
                    while (childPtr) {
                        if (childPtr->export.nodeKind == YANG_DECL_BIT) {
                            _YangNode* positionPtr = findChildNodeByTypeAndValue(childPtr, YANG_DECL_POSITION, (yyvsp[-1].text));
                            if (positionPtr) {
                                smiPrintError(currentParser, ERR_DUPLICATED, "position", (yyvsp[-1].text));
                            }
                        }
                        childPtr = childPtr->nextSiblingPtr;
                    }

                    node = addYangNode((yyvsp[-1].text), YANG_DECL_POSITION, topNode());
                }
#line 3327 "parser-yang.c"
    break;

  case 185: /* stmtEnd: ';'  */
#line 1401 "parser-yang.y"
                {}
#line 3333 "parser-yang.c"
    break;

  case 186: /* stmtEnd: '{' unknownStatement0_n '}'  */
#line 1405 "parser-yang.y"
                {}
#line 3339 "parser-yang.c"
    break;

  case 187: /* stmtSep: %empty  */
#line 1408 "parser-yang.y"
         {}
#line 3345 "parser-yang.c"
    break;

  case 189: /* unknownStatement0_n: %empty  */
#line 1416 "parser-yang.y"
                     {}
#line 3351 "parser-yang.c"
    break;

  case 197: /* $@16: %empty  */
#line 1434 "parser-yang.y"
                    {
                        node = addCTExtNode(thisModulePtr, YANG_DECL_COMPLEX_TYPE, 0, topNode(), getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)), (yyvsp[-1].text), (yyvsp[0].text));
                        pushNode(node);
                    }
#line 3360 "parser-yang.c"
    break;

  case 198: /* complexTypeStatement: complexTypeKeyword identifierStr $@16 complexTypeSpec  */
#line 1439 "parser-yang.y"
                    {
                        checkUnknownStatement();
                        pop();
                    }
#line 3369 "parser-yang.c"
    break;

  case 199: /* complexTypeSpec: ';'  */
#line 1445 "parser-yang.y"
                      {}
#line 3375 "parser-yang.c"
    break;

  case 201: /* complexTypeSubstatement_0n: %empty  */
#line 1453 "parser-yang.y"
                            {}
#line 3381 "parser-yang.c"
    break;

  case 214: /* abstractStatement: abstractKeyword trueKeyword stmtEnd  */
#line 1483 "parser-yang.y"
                {
                    node = addCTExtNode(thisModulePtr, YANG_DECL_ABSTRACT, 1, topNode(), getPrefix((yyvsp[-2].text)), getIdentifier((yyvsp[-2].text)), (yyvsp[-2].text), "true");
                }
#line 3389 "parser-yang.c"
    break;

  case 215: /* abstractStatement: abstractKeyword falseKeyword stmtEnd  */
#line 1488 "parser-yang.y"
                {
                    node = addCTExtNode(thisModulePtr, YANG_DECL_ABSTRACT, 1, topNode(), getPrefix((yyvsp[-2].text)), getIdentifier((yyvsp[-2].text)), (yyvsp[-2].text), "false");
                }
#line 3397 "parser-yang.c"
    break;

  case 216: /* $@17: %empty  */
#line 1494 "parser-yang.y"
                {
                    node = addCTExtNode(thisModulePtr, YANG_DECL_EXTENDS, 1, topNode(), getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)), (yyvsp[-1].text), (yyvsp[0].text));
                    if (node->export.nodeKind == YANG_DECL_EXTENDS) {
                        createIdentifierRef(node, getPrefix((yyvsp[0].text)), getIdentifier((yyvsp[0].text)));
                    }
                    pushNode(node);
                }
#line 3409 "parser-yang.c"
    break;

  case 217: /* extendsStatement: extendsKeyword identifierRef $@17 extendsStatementSpec  */
#line 1502 "parser-yang.y"
                {
                     pop();
                }
#line 3417 "parser-yang.c"
    break;

  case 218: /* extendsStatementSpec: ';'  */
#line 1507 "parser-yang.y"
                          {}
#line 3423 "parser-yang.c"
    break;

  case 220: /* extendsSubstatement_0n: %empty  */
#line 1515 "parser-yang.y"
                        {}
#line 3429 "parser-yang.c"
    break;

  case 225: /* $@18: %empty  */
#line 1528 "parser-yang.y"
                {
                    node = addCTExtNode(thisModulePtr, YANG_DECL_INSTANCE, 0, topNode(), getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)), (yyvsp[-1].text), (yyvsp[0].text));
                    pushNode(node);
                }
#line 3438 "parser-yang.c"
    break;

  case 226: /* instanceStatement: instanceKeyword identifierStr $@18 '{' stmtSep instanceSubstatement_0n '}'  */
#line 1536 "parser-yang.y"
                {
                    checkUnknownStatement();
                    if (topNode()->export.nodeKind != YANG_DECL_UNKNOWN_STATEMENT && getCardinality(topNode(), YANG_DECL_INSTANCE_TYPE) == 0) {
                        smiPrintErrorAtLine(currentParser, ERR_WRONG_CARDINALITY, topNode()->line, yangDeclAsString(YANG_DECL_INSTANCE_TYPE), "1");
                    }
                    pop();
                }
#line 3450 "parser-yang.c"
    break;

  case 227: /* instanceSubstatement_0n: %empty  */
#line 1545 "parser-yang.y"
                         {}
#line 3456 "parser-yang.c"
    break;

  case 236: /* $@19: %empty  */
#line 1567 "parser-yang.y"
                {
                    node = addCTExtNode(thisModulePtr, YANG_DECL_INSTANCE_LIST, 0, topNode(), getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)), (yyvsp[-1].text), (yyvsp[0].text));
                    pushNode(node);
                }
#line 3465 "parser-yang.c"
    break;

  case 237: /* instanceListStatement: instanceListKeyword identifierStr $@19 '{' stmtSep instanceListSubstatement_0n '}'  */
#line 1575 "parser-yang.y"
                {
                    checkUnknownStatement();
                    if (topNode()->export.nodeKind != YANG_DECL_UNKNOWN_STATEMENT && getCardinality(topNode(), YANG_DECL_INSTANCE_TYPE) == 0) {
                        smiPrintErrorAtLine(currentParser, ERR_WRONG_CARDINALITY, topNode()->line, yangDeclAsString(YANG_DECL_INSTANCE_TYPE), "1");
                    }
                    pop();
                }
#line 3477 "parser-yang.c"
    break;

  case 238: /* instanceListSubstatement_0n: %empty  */
#line 1584 "parser-yang.y"
                             {}
#line 3483 "parser-yang.c"
    break;

  case 249: /* instanceTypeStatement: instanceTypeKeyword identifierRef stmtEnd  */
#line 1611 "parser-yang.y"
                    {
                        node = addCTExtNode(thisModulePtr, YANG_DECL_INSTANCE_TYPE, 1, topNode(), getPrefix((yyvsp[-2].text)), getIdentifier((yyvsp[-2].text)), (yyvsp[-2].text), (yyvsp[-1].text));
                        if (node->export.nodeKind == YANG_DECL_INSTANCE_TYPE) {
                            createIdentifierRef(node, getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)));
                        }
                    }
#line 3494 "parser-yang.c"
    break;

  case 250: /* $@20: %empty  */
#line 1623 "parser-yang.y"
                    {
                        node = addYangNode((yyvsp[0].text), YANG_DECL_UNKNOWN_STATEMENT, topNode());
                        createIdentifierRef(node, getPrefix((yyvsp[0].text)), getIdentifier((yyvsp[0].text)));
                        pushNode(node);
                    }
#line 3504 "parser-yang.c"
    break;

  case 251: /* unknownStatement: identifierRefArg $@20 stmtEnd  */
#line 1629 "parser-yang.y"
                    {
                        pop();
                    }
#line 3512 "parser-yang.c"
    break;

  case 252: /* $@21: %empty  */
#line 1634 "parser-yang.y"
                    {
                        node = addYangNode((yyvsp[-1].text), YANG_DECL_UNKNOWN_STATEMENT, topNode());
                        createIdentifierRef(node, getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)));
                        node->export.extra = smiStrdup((yyvsp[0].text));
                        pushNode(node);
                    }
#line 3523 "parser-yang.c"
    break;

  case 253: /* unknownStatement: identifierRefArg string $@21 stmtEnd  */
#line 1641 "parser-yang.y"
                    {
                        pop();
                    }
#line 3531 "parser-yang.c"
    break;

  case 254: /* $@22: %empty  */
#line 1647 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[0].text), YANG_DECL_CONTAINER, topNode());
                            pushNode(node);
			}
#line 3540 "parser-yang.c"
    break;

  case 255: /* containerStatement: containerKeyword identifierStr $@22 containerSpec  */
#line 1652 "parser-yang.y"
                        {
                            pop();
			}
#line 3548 "parser-yang.c"
    break;

  case 256: /* containerSpec: ';'  */
#line 1657 "parser-yang.y"
                    {}
#line 3554 "parser-yang.c"
    break;

  case 258: /* containerSubstatement_0n: %empty  */
#line 1665 "parser-yang.y"
                          {}
#line 3560 "parser-yang.c"
    break;

  case 268: /* $@23: %empty  */
#line 1688 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_MUST, topNode());
                    pushNode(node);
		}
#line 3569 "parser-yang.c"
    break;

  case 269: /* mustStatement: mustKeyword string $@23 '{' mustSubstatement_0n '}'  */
#line 1695 "parser-yang.y"
                {
			pop();
		}
#line 3577 "parser-yang.c"
    break;

  case 270: /* mustStatement: mustKeyword string ';'  */
#line 1700 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[-1].text), YANG_DECL_MUST, topNode());
		}
#line 3585 "parser-yang.c"
    break;

  case 271: /* mustSubstatement_0n: %empty  */
#line 1705 "parser-yang.y"
                     {}
#line 3591 "parser-yang.c"
    break;

  case 277: /* presenceStatement: presenceKeyword string stmtEnd  */
#line 1720 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_PRESENCE);
                    node = addYangNode((yyvsp[-1].text), YANG_DECL_PRESENCE, topNode());
                }
#line 3600 "parser-yang.c"
    break;

  case 278: /* configStatement: configKeyword trueKeyword stmtEnd  */
#line 1727 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_CONFIG);
                    setConfig(topNode(), YANG_CONFIG_TRUE);
                    node = addYangNode("true", YANG_DECL_CONFIG, topNode());
                }
#line 3610 "parser-yang.c"
    break;

  case 279: /* configStatement: configKeyword falseKeyword stmtEnd  */
#line 1734 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_CONFIG);
                    setConfig(topNode(), YANG_CONFIG_FALSE);
                    node = addYangNode("false", YANG_DECL_CONFIG, topNode());
                }
#line 3620 "parser-yang.c"
    break;

  case 280: /* mandatoryStatement: mandatoryKeyword trueKeyword stmtEnd  */
#line 1742 "parser-yang.y"
                        {
                            uniqueNodeKind(topNode(), YANG_DECL_MANDATORY);
                            node = addYangNode("true", YANG_DECL_MANDATORY, topNode());
			}
#line 3629 "parser-yang.c"
    break;

  case 281: /* mandatoryStatement: mandatoryKeyword falseKeyword stmtEnd  */
#line 1748 "parser-yang.y"
                        {
                            uniqueNodeKind(topNode(), YANG_DECL_MANDATORY);
                            node = addYangNode("false", YANG_DECL_MANDATORY, topNode());
			}
#line 3638 "parser-yang.c"
    break;

  case 282: /* $@24: %empty  */
#line 1755 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[0].text), YANG_DECL_LEAF, topNode());
                            pushNode(node);
			}
#line 3647 "parser-yang.c"
    break;

  case 283: /* leafStatement: leafKeyword identifierStr $@24 '{' stmtSep leafSubstatement_0n '}'  */
#line 1763 "parser-yang.y"
                        {
                            if (getCardinality(topNode(), YANG_DECL_TYPE) != 1) {
                                smiPrintError(currentParser, ERR_WRONG_CARDINALITY, yangDeclAsString(YANG_DECL_TYPE), "1");
                            }
                            pop();
			}
#line 3658 "parser-yang.c"
    break;

  case 284: /* leafSubstatement_0n: %empty  */
#line 1771 "parser-yang.y"
                     {}
#line 3664 "parser-yang.c"
    break;

  case 294: /* $@25: %empty  */
#line 1794 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[0].text), YANG_DECL_LEAF_LIST, topNode());
                            pushNode(node);
			}
#line 3673 "parser-yang.c"
    break;

  case 295: /* leaf_listStatement: leaf_listKeyword identifierStr $@25 '{' stmtSep leaf_listSubstatement_0n '}'  */
#line 1802 "parser-yang.y"
                        {
                            if (getCardinality(topNode(), YANG_DECL_TYPE) != 1) {
				smiPrintError(currentParser, ERR_WRONG_CARDINALITY, yangDeclAsString(YANG_DECL_TYPE), "1");
                            }
                            pop();
			}
#line 3684 "parser-yang.c"
    break;

  case 296: /* leaf_listSubstatement_0n: %empty  */
#line 1810 "parser-yang.y"
                          {}
#line 3690 "parser-yang.c"
    break;

  case 307: /* $@26: %empty  */
#line 1835 "parser-yang.y"
                        {
                            node = addYangNode((yyvsp[0].text), YANG_DECL_LIST, topNode());
                            pushNode(node);
			}
#line 3699 "parser-yang.c"
    break;

  case 308: /* listStatement: listKeyword identifierStr $@26 '{' stmtSep listSubstatement_0n '}'  */
#line 1843 "parser-yang.y"
                        {
                            pop();
			}
#line 3707 "parser-yang.c"
    break;

  case 309: /* listSubstatement_0n: %empty  */
#line 1848 "parser-yang.y"
                     {}
#line 3713 "parser-yang.c"
    break;

  case 323: /* max_elementsStatement: max_elementsKeyword string stmtEnd  */
#line 1879 "parser-yang.y"
                    {
                        if (!isNonNegativeInteger((yyvsp[-1].text))) {                            
                            smiPrintError(currentParser, ERR_ARG_VALUE, (yyvsp[-1].text), "non-negative-integer");
                        }
                        uniqueNodeKind(topNode(), YANG_DECL_MAX_ELEMENTS);
                        node = addYangNode((yyvsp[-1].text), YANG_DECL_MAX_ELEMENTS, topNode());
                    }
#line 3725 "parser-yang.c"
    break;

  case 324: /* min_elementsStatement: min_elementsKeyword string stmtEnd  */
#line 1889 "parser-yang.y"
                    {
                        if (!isNonNegativeInteger((yyvsp[-1].text))) {
                            smiPrintError(currentParser, ERR_ARG_VALUE, (yyvsp[-1].text), "non-negative-integer");
                        }
                        uniqueNodeKind(topNode(), YANG_DECL_MIN_ELEMENTS);
                        node = addYangNode((yyvsp[-1].text), YANG_DECL_MIN_ELEMENTS, topNode());
                    }
#line 3737 "parser-yang.c"
    break;

  case 325: /* ordered_byStatement: ordered_byKeyword string stmtEnd  */
#line 1899 "parser-yang.y"
                    {
                        if (!strcmp((yyvsp[-1].text), "user") || !strcmp((yyvsp[-1].text), "system")) {
                        } else {
                            smiPrintError(thisParserPtr, ERR_IVALIDE_ORDERED_BY_VALUE, (yyvsp[-1].text));
                        }
                        uniqueNodeKind(topNode(), YANG_DECL_ORDERED_BY);
                        node = addYangNode((yyvsp[-1].text), YANG_DECL_ORDERED_BY, topNode());
                    }
#line 3750 "parser-yang.c"
    break;

  case 326: /* keyStatement: keyKeyword string stmtEnd  */
#line 1910 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_KEY);
                    node = addYangNode((yyvsp[-1].text), YANG_DECL_KEY, topNode());
                    node->info = getKeyList((yyvsp[-1].text));
		}
#line 3760 "parser-yang.c"
    break;

  case 327: /* uniqueStatement: uniqueKeyword string stmtEnd  */
#line 1918 "parser-yang.y"
                {
		    YangList *il;
                    node = addYangNode((yyvsp[-1].text), YANG_DECL_UNIQUE, topNode());
                    il = getUniqueList((yyvsp[-1].text));
                    node->info = processUniqueList(node, il);
                    freeIdentiferList(il);
		}
#line 3772 "parser-yang.c"
    break;

  case 328: /* $@27: %empty  */
#line 1928 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_CHOICE, topNode());
                    pushNode(node);
		}
#line 3781 "parser-yang.c"
    break;

  case 329: /* choiceStatement: choiceKeyword identifierStr $@27 choiceSpec  */
#line 1933 "parser-yang.y"
                {
                    pop();
		}
#line 3789 "parser-yang.c"
    break;

  case 330: /* choiceSpec: ';'  */
#line 1938 "parser-yang.y"
                {}
#line 3795 "parser-yang.c"
    break;

  case 331: /* choiceSpec: '{' stmtSep choiceSubstatement_0n '}'  */
#line 1943 "parser-yang.y"
                {}
#line 3801 "parser-yang.c"
    break;

  case 332: /* choiceSubstatement_0n: %empty  */
#line 1946 "parser-yang.y"
                       {}
#line 3807 "parser-yang.c"
    break;

  case 340: /* $@28: %empty  */
#line 1965 "parser-yang.y"
                {
                    node = findChildNodeByTypeAndValue(topNode(), YANG_DECL_CASE, (yyvsp[0].text));
                    if (node) {
                        smiPrintError(currentParser, ERR_DUPLICATED_CASE_IDENTIFIER, (yyvsp[0].text));
                    }
                    node = addYangNode((yyvsp[0].text), YANG_DECL_CASE, topNode());
                    pushNode(node);
		}
#line 3820 "parser-yang.c"
    break;

  case 341: /* caseStatement: caseKeyword identifierStr $@28 caseSpec  */
#line 1974 "parser-yang.y"
                {
                    pop();
		}
#line 3828 "parser-yang.c"
    break;

  case 347: /* caseSpec: ';'  */
#line 1989 "parser-yang.y"
                {}
#line 3834 "parser-yang.c"
    break;

  case 348: /* caseSpec: '{' stmtSep caseSubstatement_0n '}'  */
#line 1994 "parser-yang.y"
                {}
#line 3840 "parser-yang.c"
    break;

  case 349: /* caseSubstatement_0n: %empty  */
#line 1997 "parser-yang.y"
                     {}
#line 3846 "parser-yang.c"
    break;

  case 363: /* $@29: %empty  */
#line 2031 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_GROUPING, topNode());
                    pushNode(node);
		}
#line 3855 "parser-yang.c"
    break;

  case 364: /* groupingStatement: groupingKeyword identifierStr $@29 '{' stmtSep groupingSubstatement_0n '}'  */
#line 2039 "parser-yang.y"
                {
                    pop();
		}
#line 3863 "parser-yang.c"
    break;

  case 365: /* groupingSubstatement_0n: %empty  */
#line 2044 "parser-yang.y"
                         {}
#line 3869 "parser-yang.c"
    break;

  case 373: /* $@30: %empty  */
#line 2063 "parser-yang.y"
            {
                node = addYangNode((yyvsp[0].text), YANG_DECL_USES, topNode());
                createIdentifierRef(node, getPrefix((yyvsp[0].text)), getIdentifier((yyvsp[0].text)));
                pushNode(node);
            }
#line 3879 "parser-yang.c"
    break;

  case 374: /* usesStatement: usesKeyword identifierRef $@30 '{' usesSubstatement_0n '}'  */
#line 2071 "parser-yang.y"
            {
                pop();
            }
#line 3887 "parser-yang.c"
    break;

  case 375: /* usesStatement: usesKeyword identifierRef ';'  */
#line 2076 "parser-yang.y"
            {
                node = addYangNode((yyvsp[-1].text), YANG_DECL_USES, topNode());
                createIdentifierRef(node, getPrefix((yyvsp[-1].text)), getIdentifier((yyvsp[-1].text)));
            }
#line 3896 "parser-yang.c"
    break;

  case 376: /* usesSubstatement_0n: %empty  */
#line 2082 "parser-yang.y"
                     {}
#line 3902 "parser-yang.c"
    break;

  case 385: /* $@31: %empty  */
#line 2104 "parser-yang.y"
                    {
                        if (!isDescendantSchemaNodeid((yyvsp[0].text))) {
                            smiPrintError(thisParserPtr, ERR_DESCEDANT_FORM, (yyvsp[0].text));
                        }
                        node = addYangNode((yyvsp[0].text), YANG_DECL_REFINE, topNode());
                        pushNode(node);
                    }
#line 3914 "parser-yang.c"
    break;

  case 386: /* refineStatement: refineKeyword string $@31 refineSpec  */
#line 2112 "parser-yang.y"
                    {
                        pop();
                    }
#line 3922 "parser-yang.c"
    break;

  case 387: /* refineSpec: ';'  */
#line 2117 "parser-yang.y"
                {}
#line 3928 "parser-yang.c"
    break;

  case 388: /* refineSpec: '{' stmtSep refineSubstatement '}'  */
#line 2122 "parser-yang.y"
                {}
#line 3934 "parser-yang.c"
    break;

  case 390: /* refine_0n: %empty  */
#line 2127 "parser-yang.y"
            {}
#line 3940 "parser-yang.c"
    break;

  case 401: /* $@32: %empty  */
#line 2152 "parser-yang.y"
                {
                    if (topDecl() == YANG_DECL_USES || topDecl() == YANG_DECL_INSTANCE || topDecl() == YANG_DECL_INSTANCE_LIST) {
                        if (!isDescendantSchemaNodeid((yyvsp[0].text))) {
                            smiPrintError(thisParserPtr, ERR_DESCEDANT_FORM, (yyvsp[0].text));
                        }
                    } else {
                        if (!isAbsoluteSchemaNodeid((yyvsp[0].text))) {
                            smiPrintError(thisParserPtr, ERR_ABSOLUTE_FORM, (yyvsp[0].text));
                        }
                    }
                    node = addYangNode((yyvsp[0].text), YANG_DECL_AUGMENT, topNode());
                    pushNode(node);
		}
#line 3958 "parser-yang.c"
    break;

  case 402: /* augmentStatement: augmentKeyword string $@32 '{' stmtSep augmentSubstatement_0n '}'  */
#line 2169 "parser-yang.y"
                {
                    int count = 0;
		    node = topNode()->firstChildPtr;
                    while (node) {
                        if (node->export.nodeKind == YANG_DECL_CASE ||
                            isDataDefNode(node)) {
                                count++;
                        }
                        node = node->nextSiblingPtr;
                    }
                    if (count == 0) {
                        smiPrintError(thisParserPtr, ERR_DATADEF_NODE_REQUIRED, (yyvsp[-5].text));
                    }

                    pop();
		}
#line 3979 "parser-yang.c"
    break;

  case 403: /* augmentSubstatement_0n: stmtSep  */
#line 2187 "parser-yang.y"
                                {}
#line 3985 "parser-yang.c"
    break;

  case 412: /* whenStatement: whenKeyword string stmtEnd  */
#line 2209 "parser-yang.y"
            {
                uniqueNodeKind(topNode(), YANG_DECL_WHEN);
                node = addYangNode((yyvsp[-1].text), YANG_DECL_WHEN, topNode());
            }
#line 3994 "parser-yang.c"
    break;

  case 413: /* $@33: %empty  */
#line 2216 "parser-yang.y"
            {
                node = addYangNode((yyvsp[0].text), YANG_DECL_RPC, topNode());
                pushNode(node);
            }
#line 4003 "parser-yang.c"
    break;

  case 414: /* rpcStatement: rpcKeyword identifierStr $@33 rpcSpec  */
#line 2221 "parser-yang.y"
            {
                pop();
            }
#line 4011 "parser-yang.c"
    break;

  case 415: /* rpcSpec: ';'  */
#line 2226 "parser-yang.y"
                {}
#line 4017 "parser-yang.c"
    break;

  case 416: /* rpcSpec: '{' stmtSep rpcSubstatement_0n '}'  */
#line 2231 "parser-yang.y"
                {}
#line 4023 "parser-yang.c"
    break;

  case 417: /* rpcSubstatement_0n: %empty  */
#line 2234 "parser-yang.y"
                    {}
#line 4029 "parser-yang.c"
    break;

  case 427: /* $@34: %empty  */
#line 2257 "parser-yang.y"
                {
                    node = addYangNode(NULL, YANG_DECL_INPUT, topNode());
                    pushNode(node);
		}
#line 4038 "parser-yang.c"
    break;

  case 428: /* inputStatement: inputKeyword $@34 '{' stmtSep inputOutputSubstatement_0n '}'  */
#line 2265 "parser-yang.y"
                {
                    int numberDataDefStmts = 0;
                    _YangNode *childPtr = topNode()->firstChildPtr;
                    while (childPtr) {
                        if (!(childPtr->export.nodeKind == YANG_DECL_TYPEDEF ||
                            childPtr->export.nodeKind == YANG_DECL_GROUPING)) {
                                numberDataDefStmts++;
                            }
                        childPtr = childPtr->nextSiblingPtr;
                    }
                    if (!numberDataDefStmts) {
                        smiPrintError(thisParserPtr, ERR_DATA_DEF_REQUIRED, "input");
                    }
                    pop();
		}
#line 4058 "parser-yang.c"
    break;

  case 434: /* $@35: %empty  */
#line 2295 "parser-yang.y"
                {
                    node = addYangNode(NULL, YANG_DECL_OUTPUT, topNode());
                    pushNode(node);
		}
#line 4067 "parser-yang.c"
    break;

  case 435: /* outputStatement: outputKeyword $@35 '{' stmtSep inputOutputSubstatement_0n '}'  */
#line 2303 "parser-yang.y"
                {
                    int numberDataDefStmts = 0;
                    _YangNode *childPtr = topNode()->firstChildPtr;
                    while (childPtr) {
                        if (!(childPtr->export.nodeKind == YANG_DECL_TYPEDEF ||
                            childPtr->export.nodeKind == YANG_DECL_GROUPING)) {
                                numberDataDefStmts++;
                            }
                        childPtr = childPtr->nextSiblingPtr;
                    }
                    if (!numberDataDefStmts) {
                        smiPrintError(thisParserPtr, ERR_DATA_DEF_REQUIRED, "input");
                    }
                    pop();
		}
#line 4087 "parser-yang.c"
    break;

  case 436: /* $@36: %empty  */
#line 2322 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_NOTIFICATION, topNode());
                    pushNode(node);
                }
#line 4096 "parser-yang.c"
    break;

  case 437: /* notificationStatement: notificationKeyword identifierStr $@36 notificationSpec  */
#line 2327 "parser-yang.y"
                {
                    pop();
                }
#line 4104 "parser-yang.c"
    break;

  case 438: /* notificationSpec: ';'  */
#line 2332 "parser-yang.y"
                        {}
#line 4110 "parser-yang.c"
    break;

  case 439: /* notificationSpec: '{' stmtSep notificationSubstatement_0n '}'  */
#line 2337 "parser-yang.y"
                        {}
#line 4116 "parser-yang.c"
    break;

  case 440: /* notificationSubstatement_0n: %empty  */
#line 2341 "parser-yang.y"
                             {}
#line 4122 "parser-yang.c"
    break;

  case 449: /* $@37: %empty  */
#line 2362 "parser-yang.y"
                {
                        node = addYangNode((yyvsp[0].text), YANG_DECL_DEVIATION, topNode());
                        pushNode(node);
                }
#line 4131 "parser-yang.c"
    break;

  case 450: /* deviationStatement: deviationKeyword string $@37 '{' stmtSep deviationSubstatement_0n '}'  */
#line 2370 "parser-yang.y"
                {
                    pop();
                }
#line 4139 "parser-yang.c"
    break;

  case 459: /* deviateNotSupported: deviateKeyword notSupportedKeyword ';'  */
#line 2393 "parser-yang.y"
                    {
                        uniqueNodeKind(topNode(), YANG_DECL_DEVIATE);
                        node = addYangNode("not-supported", YANG_DECL_DEVIATE, topNode());
                    }
#line 4148 "parser-yang.c"
    break;

  case 460: /* deviateNotSupported: deviateKeyword notSupportedKeyword '{' stmtSep '}'  */
#line 2399 "parser-yang.y"
                    {
                        uniqueNodeKind(topNode(), YANG_DECL_DEVIATE);
                        node = addYangNode("not-supported", YANG_DECL_DEVIATE, topNode());
                    }
#line 4157 "parser-yang.c"
    break;

  case 461: /* $@38: %empty  */
#line 2406 "parser-yang.y"
                    {
                        node = addYangNode("add", YANG_DECL_DEVIATE, topNode());
                        pushNode(node);
                    }
#line 4166 "parser-yang.c"
    break;

  case 462: /* deviateAddStatement: deviateKeyword addKeyword $@38 deviateAddSpec  */
#line 2411 "parser-yang.y"
                    {
                        pop();
                    }
#line 4174 "parser-yang.c"
    break;

  case 463: /* deviateAddSpec: ';'  */
#line 2416 "parser-yang.y"
                    {}
#line 4180 "parser-yang.c"
    break;

  case 464: /* deviateAddSpec: '{' stmtSep deviateAddSubstatement_0n '}'  */
#line 2421 "parser-yang.y"
                    {}
#line 4186 "parser-yang.c"
    break;

  case 465: /* deviateAddSubstatement_0n: %empty  */
#line 2424 "parser-yang.y"
                           {}
#line 4192 "parser-yang.c"
    break;

  case 475: /* $@39: %empty  */
#line 2446 "parser-yang.y"
                    {
                        node = addYangNode("delete", YANG_DECL_DEVIATE, topNode());
                        pushNode(node);
                    }
#line 4201 "parser-yang.c"
    break;

  case 476: /* deviateDeleteStatement: deviateKeyword deleteKeyword $@39 deviateDeleteSpec  */
#line 2451 "parser-yang.y"
                    {
                        pop();
                    }
#line 4209 "parser-yang.c"
    break;

  case 477: /* deviateDeleteSpec: ';'  */
#line 2456 "parser-yang.y"
                       {}
#line 4215 "parser-yang.c"
    break;

  case 478: /* deviateDeleteSpec: '{' stmtSep deviateDeleteSubstatement_0n '}'  */
#line 2461 "parser-yang.y"
                    {}
#line 4221 "parser-yang.c"
    break;

  case 479: /* deviateDeleteSubstatement_0n: %empty  */
#line 2464 "parser-yang.y"
                              {}
#line 4227 "parser-yang.c"
    break;

  case 485: /* $@40: %empty  */
#line 2477 "parser-yang.y"
                    {
                        node = addYangNode("replace", YANG_DECL_DEVIATE, topNode());
                        pushNode(node);
                    }
#line 4236 "parser-yang.c"
    break;

  case 486: /* deviateReplaceStatement: deviateKeyword replaceKeyword $@40 deviateReplaceSpec  */
#line 2482 "parser-yang.y"
                    {
                        pop();
                    }
#line 4244 "parser-yang.c"
    break;

  case 487: /* deviateReplaceSpec: ';'  */
#line 2487 "parser-yang.y"
                        {}
#line 4250 "parser-yang.c"
    break;

  case 488: /* deviateReplaceSpec: '{' stmtSep deviateReplaceSubstatement_0n '}'  */
#line 2492 "parser-yang.y"
                    {}
#line 4256 "parser-yang.c"
    break;

  case 489: /* deviateReplaceSubstatement_0n: %empty  */
#line 2495 "parser-yang.y"
                               {}
#line 4262 "parser-yang.c"
    break;

  case 498: /* $@41: %empty  */
#line 2516 "parser-yang.y"
                {
            node = addYangNode((yyvsp[0].text), YANG_DECL_ANYXML, topNode());
            pushNode(node);
		}
#line 4271 "parser-yang.c"
    break;

  case 499: /* anyXMLStatement: anyXMLKeyword identifierStr $@41 anyXMLSpec  */
#line 2521 "parser-yang.y"
                {
			pop();
		}
#line 4279 "parser-yang.c"
    break;

  case 500: /* anyXMLSpec: ';'  */
#line 2526 "parser-yang.y"
                {}
#line 4285 "parser-yang.c"
    break;

  case 501: /* anyXMLSpec: '{' stmtSep anyXMLSubstatement_0n '}'  */
#line 2531 "parser-yang.y"
                {}
#line 4291 "parser-yang.c"
    break;

  case 502: /* anyXMLSubstatement_0n: %empty  */
#line 2534 "parser-yang.y"
                       {}
#line 4297 "parser-yang.c"
    break;

  case 509: /* $@42: %empty  */
#line 2551 "parser-yang.y"
                {
                    node = addYangNode((yyvsp[0].text), YANG_DECL_EXTENSION, topNode());
                    pushNode(node);
		}
#line 4306 "parser-yang.c"
    break;

  case 510: /* extensionStatement: extensionKeyword identifierStr $@42 extensionStatementBody  */
#line 2556 "parser-yang.y"
                {
                    pop();
		}
#line 4314 "parser-yang.c"
    break;

  case 511: /* extensionStatementBody: '{' stmtSep extensionSubstatement_0n '}'  */
#line 2561 "parser-yang.y"
                                                                  {}
#line 4320 "parser-yang.c"
    break;

  case 512: /* extensionStatementBody: ';'  */
#line 2563 "parser-yang.y"
                         {}
#line 4326 "parser-yang.c"
    break;

  case 513: /* extensionSubstatement_0n: %empty  */
#line 2566 "parser-yang.y"
                          {}
#line 4332 "parser-yang.c"
    break;

  case 519: /* $@43: %empty  */
#line 2581 "parser-yang.y"
                    {
                        uniqueNodeKind(topNode(), YANG_DECL_ARGUMENT);
                        node = addYangNode((yyvsp[0].text), YANG_DECL_ARGUMENT, topNode());
                        pushNode(node);
                    }
#line 4342 "parser-yang.c"
    break;

  case 520: /* argumentStatement: argumentKeyword identifierStr $@43 argumentStatementBody  */
#line 2587 "parser-yang.y"
                    {
                        pop();
                    }
#line 4350 "parser-yang.c"
    break;

  case 521: /* argumentStatementBody: '{' stmtSep yinElementOptional '}'  */
#line 2592 "parser-yang.y"
                                                           {}
#line 4356 "parser-yang.c"
    break;

  case 522: /* argumentStatementBody: ';'  */
#line 2594 "parser-yang.y"
                             {}
#line 4362 "parser-yang.c"
    break;

  case 523: /* yinElementOptional: %empty  */
#line 2597 "parser-yang.y"
                    {}
#line 4368 "parser-yang.c"
    break;

  case 524: /* yinElementOptional: yinElementKeyword trueKeyword stmtEnd stmtSep  */
#line 2600 "parser-yang.y"
                    {
                        addYangNode("true", YANG_DECL_YIN_ELEMENT, topNode());
                    }
#line 4376 "parser-yang.c"
    break;

  case 525: /* yinElementOptional: yinElementKeyword falseKeyword stmtEnd stmtSep  */
#line 2605 "parser-yang.y"
                    {
                        addYangNode("false", YANG_DECL_YIN_ELEMENT, topNode());
                    }
#line 4384 "parser-yang.c"
    break;

  case 526: /* unitsStatement: unitsKeyword string stmtEnd  */
#line 2611 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_UNITS);
                    addYangNode((yyvsp[-1].text), YANG_DECL_UNITS, topNode());
                }
#line 4393 "parser-yang.c"
    break;

  case 527: /* defaultStatement: defaultKeyword string stmtEnd  */
#line 2618 "parser-yang.y"
                {
                    uniqueNodeKind(topNode(), YANG_DECL_DEFAULT);
                    addYangNode((yyvsp[-1].text), YANG_DECL_DEFAULT, topNode());
                }
#line 4402 "parser-yang.c"
    break;

  case 539: /* identifierStr: augmentKeyword  */
#line 2647 "parser-yang.y"
                                 {(yyval.text) = (yyvsp[0].text);}
#line 4408 "parser-yang.c"
    break;

  case 540: /* identifierStr: belongs_toKeyword  */
#line 2647 "parser-yang.y"
                                                                {(yyval.text) = (yyvsp[0].text);}
#line 4414 "parser-yang.c"
    break;

  case 541: /* identifierStr: choiceKeyword  */
#line 2647 "parser-yang.y"
                                                                                           {(yyval.text) = (yyvsp[0].text);}
#line 4420 "parser-yang.c"
    break;

  case 542: /* identifierStr: configKeyword  */
#line 2647 "parser-yang.y"
                                                                                                                      {(yyval.text) = (yyvsp[0].text);}
#line 4426 "parser-yang.c"
    break;

  case 543: /* identifierStr: contactKeyword  */
#line 2647 "parser-yang.y"
                                                                                                                                                  {(yyval.text) = (yyvsp[0].text);}
#line 4432 "parser-yang.c"
    break;

  case 544: /* identifierStr: containerKeyword  */
#line 2647 "parser-yang.y"
                                                                                                                                                                                {(yyval.text) = (yyvsp[0].text);}
#line 4438 "parser-yang.c"
    break;

  case 545: /* identifierStr: defaultKeyword  */
#line 2647 "parser-yang.y"
                                                                                                                                                                                                            {(yyval.text) = (yyvsp[0].text);}
#line 4444 "parser-yang.c"
    break;

  case 546: /* identifierStr: descriptionKeyword  */
#line 2647 "parser-yang.y"
                                                                                                                                                                                                                                            {(yyval.text) = (yyvsp[0].text);}
#line 4450 "parser-yang.c"
    break;

  case 547: /* identifierStr: enumKeyword  */
#line 2648 "parser-yang.y"
                              {(yyval.text) = (yyvsp[0].text);}
#line 4456 "parser-yang.c"
    break;

  case 548: /* identifierStr: error_app_tagKeyword  */
#line 2648 "parser-yang.y"
                                                                 {(yyval.text) = (yyvsp[0].text);}
#line 4462 "parser-yang.c"
    break;

  case 549: /* identifierStr: error_messageKeyword  */
#line 2648 "parser-yang.y"
                                                                                                    {(yyval.text) = (yyvsp[0].text);}
#line 4468 "parser-yang.c"
    break;

  case 550: /* identifierStr: extensionKeyword  */
#line 2648 "parser-yang.y"
                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4474 "parser-yang.c"
    break;

  case 551: /* identifierStr: groupingKeyword  */
#line 2648 "parser-yang.y"
                                                                                                                                                                 {(yyval.text) = (yyvsp[0].text);}
#line 4480 "parser-yang.c"
    break;

  case 552: /* identifierStr: importKeyword  */
#line 2648 "parser-yang.y"
                                                                                                                                                                                             {(yyval.text) = (yyvsp[0].text);}
#line 4486 "parser-yang.c"
    break;

  case 553: /* identifierStr: includeKeyword  */
#line 2648 "parser-yang.y"
                                                                                                                                                                                                                          {(yyval.text) = (yyvsp[0].text);}
#line 4492 "parser-yang.c"
    break;

  case 554: /* identifierStr: keyKeyword  */
#line 2648 "parser-yang.y"
                                                                                                                                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4498 "parser-yang.c"
    break;

  case 555: /* identifierStr: leafKeyword  */
#line 2649 "parser-yang.y"
                               {(yyval.text) = (yyvsp[0].text);}
#line 4504 "parser-yang.c"
    break;

  case 556: /* identifierStr: leaf_listKeyword  */
#line 2649 "parser-yang.y"
                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4510 "parser-yang.c"
    break;

  case 557: /* identifierStr: lengthKeyword  */
#line 2649 "parser-yang.y"
                                                                                          {(yyval.text) = (yyvsp[0].text);}
#line 4516 "parser-yang.c"
    break;

  case 558: /* identifierStr: listKeyword  */
#line 2649 "parser-yang.y"
                                                                                                                    {(yyval.text) = (yyvsp[0].text);}
#line 4522 "parser-yang.c"
    break;

  case 559: /* identifierStr: mandatoryKeyword  */
#line 2649 "parser-yang.y"
                                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4528 "parser-yang.c"
    break;

  case 560: /* identifierStr: max_elementsKeyword  */
#line 2649 "parser-yang.y"
                                                                                                                                                                                     {(yyval.text) = (yyvsp[0].text);}
#line 4534 "parser-yang.c"
    break;

  case 561: /* identifierStr: min_elementsKeyword  */
#line 2649 "parser-yang.y"
                                                                                                                                                                                                                       {(yyval.text) = (yyvsp[0].text);}
#line 4540 "parser-yang.c"
    break;

  case 562: /* identifierStr: moduleKeyword  */
#line 2649 "parser-yang.y"
                                                                                                                                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4546 "parser-yang.c"
    break;

  case 563: /* identifierStr: submoduleKeyword  */
#line 2650 "parser-yang.y"
                                    {(yyval.text) = (yyvsp[0].text);}
#line 4552 "parser-yang.c"
    break;

  case 564: /* identifierStr: mustKeyword  */
#line 2650 "parser-yang.y"
                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4558 "parser-yang.c"
    break;

  case 565: /* identifierStr: namespaceKeyword  */
#line 2650 "parser-yang.y"
                                                                                             {(yyval.text) = (yyvsp[0].text);}
#line 4564 "parser-yang.c"
    break;

  case 566: /* identifierStr: ordered_byKeyword  */
#line 2650 "parser-yang.y"
                                                                                                                             {(yyval.text) = (yyvsp[0].text);}
#line 4570 "parser-yang.c"
    break;

  case 567: /* identifierStr: organizationKeyword  */
#line 2650 "parser-yang.y"
                                                                                                                                                               {(yyval.text) = (yyvsp[0].text);}
#line 4576 "parser-yang.c"
    break;

  case 568: /* identifierStr: prefixKeyword  */
#line 2650 "parser-yang.y"
                                                                                                                                                                                           {(yyval.text) = (yyvsp[0].text);}
#line 4582 "parser-yang.c"
    break;

  case 569: /* identifierStr: rangeKeyword  */
#line 2650 "parser-yang.y"
                                                                                                                                                                                                                      {(yyval.text) = (yyvsp[0].text);}
#line 4588 "parser-yang.c"
    break;

  case 570: /* identifierStr: referenceKeyword  */
#line 2650 "parser-yang.y"
                                                                                                                                                                                                                                                     {(yyval.text) = (yyvsp[0].text);}
#line 4594 "parser-yang.c"
    break;

  case 571: /* identifierStr: patternKeyword  */
#line 2651 "parser-yang.y"
                                  {(yyval.text) = (yyvsp[0].text);}
#line 4600 "parser-yang.c"
    break;

  case 572: /* identifierStr: revisionKeyword  */
#line 2651 "parser-yang.y"
                                                                {(yyval.text) = (yyvsp[0].text);}
#line 4606 "parser-yang.c"
    break;

  case 573: /* identifierStr: statusKeyword  */
#line 2651 "parser-yang.y"
                                                                                            {(yyval.text) = (yyvsp[0].text);}
#line 4612 "parser-yang.c"
    break;

  case 574: /* identifierStr: typeKeyword  */
#line 2651 "parser-yang.y"
                                                                                                                      {(yyval.text) = (yyvsp[0].text);}
#line 4618 "parser-yang.c"
    break;

  case 575: /* identifierStr: typedefKeyword  */
#line 2651 "parser-yang.y"
                                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4624 "parser-yang.c"
    break;

  case 576: /* identifierStr: uniqueKeyword  */
#line 2651 "parser-yang.y"
                                                                                                                                                                               {(yyval.text) = (yyvsp[0].text);}
#line 4630 "parser-yang.c"
    break;

  case 577: /* identifierStr: unitsKeyword  */
#line 2651 "parser-yang.y"
                                                                                                                                                                                                          {(yyval.text) = (yyvsp[0].text);}
#line 4636 "parser-yang.c"
    break;

  case 578: /* identifierStr: usesKeyword  */
#line 2651 "parser-yang.y"
                                                                                                                                                                                                                                    {(yyval.text) = (yyvsp[0].text);}
#line 4642 "parser-yang.c"
    break;

  case 579: /* identifierStr: valueKeyword  */
#line 2651 "parser-yang.y"
                                                                                                                                                                                                                                                               {(yyval.text) = (yyvsp[0].text);}
#line 4648 "parser-yang.c"
    break;

  case 580: /* identifierStr: whenKeyword  */
#line 2652 "parser-yang.y"
                               {(yyval.text) = (yyvsp[0].text);}
#line 4654 "parser-yang.c"
    break;

  case 581: /* identifierStr: bitKeyword  */
#line 2652 "parser-yang.y"
                                                        {(yyval.text) = (yyvsp[0].text);}
#line 4660 "parser-yang.c"
    break;

  case 582: /* identifierStr: pathKeyword  */
#line 2652 "parser-yang.y"
                                                                                  {(yyval.text) = (yyvsp[0].text);}
#line 4666 "parser-yang.c"
    break;

  case 583: /* identifierStr: anyXMLKeyword  */
#line 2652 "parser-yang.y"
                                                                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4672 "parser-yang.c"
    break;

  case 584: /* identifierStr: deprecatedKeyword  */
#line 2652 "parser-yang.y"
                                                                                                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4678 "parser-yang.c"
    break;

  case 585: /* identifierStr: currentKeyword  */
#line 2652 "parser-yang.y"
                                                                                                                                                                           {(yyval.text) = (yyvsp[0].text);}
#line 4684 "parser-yang.c"
    break;

  case 586: /* identifierStr: obsoleteKeyword  */
#line 2652 "parser-yang.y"
                                                                                                                                                                                                         {(yyval.text) = (yyvsp[0].text);}
#line 4690 "parser-yang.c"
    break;

  case 587: /* identifierStr: trueKeyword  */
#line 2652 "parser-yang.y"
                                                                                                                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4696 "parser-yang.c"
    break;

  case 588: /* identifierStr: falseKeyword  */
#line 2652 "parser-yang.y"
                                                                                                                                                                                                                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4702 "parser-yang.c"
    break;

  case 589: /* identifierStr: caseKeyword  */
#line 2653 "parser-yang.y"
                               {(yyval.text) = (yyvsp[0].text);}
#line 4708 "parser-yang.c"
    break;

  case 590: /* identifierStr: inputKeyword  */
#line 2653 "parser-yang.y"
                                                          {(yyval.text) = (yyvsp[0].text);}
#line 4714 "parser-yang.c"
    break;

  case 591: /* identifierStr: outputKeyword  */
#line 2653 "parser-yang.y"
                                                                                      {(yyval.text) = (yyvsp[0].text);}
#line 4720 "parser-yang.c"
    break;

  case 592: /* identifierStr: rpcKeyword  */
#line 2653 "parser-yang.y"
                                                                                                               {(yyval.text) = (yyvsp[0].text);}
#line 4726 "parser-yang.c"
    break;

  case 593: /* identifierStr: notificationKeyword  */
#line 2653 "parser-yang.y"
                                                                                                                                                 {(yyval.text) = (yyvsp[0].text);}
#line 4732 "parser-yang.c"
    break;

  case 594: /* identifierStr: argumentKeyword  */
#line 2653 "parser-yang.y"
                                                                                                                                                                               {(yyval.text) = (yyvsp[0].text);}
#line 4738 "parser-yang.c"
    break;

  case 595: /* identifierStr: yangversionKeyword  */
#line 2653 "parser-yang.y"
                                                                                                                                                                                                                {(yyval.text) = (yyvsp[0].text);}
#line 4744 "parser-yang.c"
    break;

  case 596: /* identifierStr: baseKeyword  */
#line 2653 "parser-yang.y"
                                                                                                                                                                                                                                          {(yyval.text) = (yyvsp[0].text);}
#line 4750 "parser-yang.c"
    break;

  case 597: /* identifierStr: deviationKeyword  */
#line 2654 "parser-yang.y"
                                    {(yyval.text) = (yyvsp[0].text);}
#line 4756 "parser-yang.c"
    break;

  case 598: /* identifierStr: deviateKeyword  */
#line 2654 "parser-yang.y"
                                                                 {(yyval.text) = (yyvsp[0].text);}
#line 4762 "parser-yang.c"
    break;

  case 599: /* identifierStr: featureKeyword  */
#line 2654 "parser-yang.y"
                                                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4768 "parser-yang.c"
    break;

  case 600: /* identifierStr: identityKeyword  */
#line 2654 "parser-yang.y"
                                                                                                                            {(yyval.text) = (yyvsp[0].text);}
#line 4774 "parser-yang.c"
    break;

  case 601: /* identifierStr: ifFeatureKeyword  */
#line 2654 "parser-yang.y"
                                                                                                                                                           {(yyval.text) = (yyvsp[0].text);}
#line 4780 "parser-yang.c"
    break;

  case 602: /* identifierStr: positionKeyword  */
#line 2654 "parser-yang.y"
                                                                                                                                                                                         {(yyval.text) = (yyvsp[0].text);}
#line 4786 "parser-yang.c"
    break;

  case 603: /* identifierStr: presenceKeyword  */
#line 2654 "parser-yang.y"
                                                                                                                                                                                                                       {(yyval.text) = (yyvsp[0].text);}
#line 4792 "parser-yang.c"
    break;

  case 604: /* identifierStr: refineKeyword  */
#line 2654 "parser-yang.y"
                                                                                                                                                                                                                                                   {(yyval.text) = (yyvsp[0].text);}
#line 4798 "parser-yang.c"
    break;

  case 605: /* identifierStr: requireInstanceKeyword  */
#line 2655 "parser-yang.y"
                                          {(yyval.text) = (yyvsp[0].text);}
#line 4804 "parser-yang.c"
    break;

  case 606: /* identifierStr: yinElementKeyword  */
#line 2655 "parser-yang.y"
                                                                          {(yyval.text) = (yyvsp[0].text);}
#line 4810 "parser-yang.c"
    break;

  case 607: /* identifierStr: notSupportedKeyword  */
#line 2655 "parser-yang.y"
                                                                                                            {(yyval.text) = (yyvsp[0].text);}
#line 4816 "parser-yang.c"
    break;

  case 608: /* identifierStr: addKeyword  */
#line 2655 "parser-yang.y"
                                                                                                                                     {(yyval.text) = (yyvsp[0].text);}
#line 4822 "parser-yang.c"
    break;

  case 609: /* identifierStr: deleteKeyword  */
#line 2655 "parser-yang.y"
                                                                                                                                                                 {(yyval.text) = (yyvsp[0].text);}
#line 4828 "parser-yang.c"
    break;

  case 610: /* identifierStr: replaceKeyword  */
#line 2655 "parser-yang.y"
                                                                                                                                                                                              {(yyval.text) = (yyvsp[0].text);}
#line 4834 "parser-yang.c"
    break;

  case 611: /* booleanValue: trueKeyword  */
#line 2659 "parser-yang.y"
                {
                    (yyval.rc) = YANG_BOOLEAN_TRUE;
                }
#line 4842 "parser-yang.c"
    break;

  case 612: /* booleanValue: falseKeyword  */
#line 2664 "parser-yang.y"
                {
                    (yyval.rc) = YANG_BOOLEAN_FALSE;
                }
#line 4850 "parser-yang.c"
    break;


#line 4854 "parser-yang.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parserPtr, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parserPtr);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parserPtr);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (parserPtr, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parserPtr);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parserPtr);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2680 "parser-yang.y"


#endif			
